------------------------------------------------------------------
------------------- Super Meter - Addon Loader -------------------
------------------------------------------------------------------

function SuperMeter.Load(params)
	if SuperMeter.Player.id then return end

	local player = Inspect.Unit.Detail("player")

	if player and player.name and player.id then
		SuperMeter.Player = {combat = player.combat, id = player.id, name = player.name}
	end

	if player.combat or player.pvp then
		SuperMeter.Enter()
	end
end

function SuperMeter.Command(params)
	local o = SuperMeter.Interface

	if params == "switch" then
		o.cmdswitch.Event:LeftClick()
		return
	elseif params == "toggle" then
		o.cmdtoggle.Event:LeftClick()
		return
	elseif params == "reset" then
		o.cmdreset.Event:LeftClick()
		return
	end

	SuperMeter.Options()
end

function SuperMeter.Start(params)
	if SuperMeter_start then return end

	if params == "SuperMeter" then
		SuperMeter.Interface = SuperMeter.Build()
		SuperMeter.Export = SuperMeter_export
		SuperMeter.Interface.Display(true)
		SuperMeter.Interface.Relation()
		SuperMeter_start = true
	end
end

table.insert(Command.Slash.Register("SM"), {SuperMeter.Command, "SuperMeter", "Slash Command"})
table.insert(Event.Unit.Availability.Full, {SuperMeter.Load, "SuperMeter", "Player Load"})
table.insert(Event.Addon.Load.End, {SuperMeter.Start, "SuperMeter", "Addon Load"})