------------------------------------------------------------------
------------------ Super Meter - User Interface ------------------
------------------------------------------------------------------

function SuperMeter.Build()
	local effects = {colorR = 0.62, colorG = 0.62, colorB = 0.62}
	local trim = SuperMeter.Metrics("offset") / 2
	local o = {state = {}}
	local disable = {}

	o.main = UI.CreateContext("Context")
	o.main:SetVisible(SuperMeter_enabled)

	o.mainbg = UI.CreateFrame("Text", "Super Meter Main Background", o.main)
	o.mainbg:SetPoint("TOPCENTER", o.main, "TOPCENTER", 0, 4)
	o.mainbg:SetParent(o.main)
	o.mainbg:SetHeight(42.88)

	o.title = UI.CreateFrame("Text", "Super Meter Main Title", o.main)
	o.title:SetParent(o.main)
	o.title:SetLayer(2)

	o.menu = UI.CreateFrame("Text", "Super Meter Main Menu", o.main)
	o.menu:SetPoint("TOPLEFT", o.main, "TOPLEFT", 6.88, 4)
	o.menu:SetParent(o.main)
	o.menu:SetLayer(2)

	o.clear = UI.CreateFrame("Text", "Super Meter Main Clear", o.main)
	o.clear:SetPoint("TOPRIGHT", o.main, "TOPRIGHT", -40, 4)
	o.clear:SetParent(o.main)
	o.clear:SetLayer(2)

	o.new = UI.CreateFrame("Text", "Super Meter Main New", o.main)
	o.new:SetPoint("TOPCENTER", o.clear, "TOPCENTER", 12.088, 0)
	o.new:SetParent(o.main)
	o.new:SetLayer(2)

	o.force = UI.CreateFrame("Text", "Super Meter Main Force", o.main)
	o.force:SetPoint("TOPCENTER", o.new, "TOPCENTER", 10.888, 0)
	o.force:SetParent(o.main)
	o.force:SetLayer(2)

	o.log = UI.CreateFrame("Text", "Super Meter Main Log", o.main)
	o.log:SetPoint("TOPCENTER", o.force, "TOPCENTER", 10.480, 0)
	o.log:SetParent(o.main)
	o.log:SetLayer(2)

	o.help = UI.CreateFrame("Text", "Super Meter Main Help", o.main)
	o.help:SetPoint("TOPCENTER", o.force, "TOPCENTER", 10.888, 0)
	o.help:SetParent(o.main)
	o.help:SetLayer(2)

	o.time = UI.CreateFrame("Text", "Super Meter Time Frame", o.main)
	o.time:SetPoint("TOPLEFT", o.main, "TOPLEFT", 10.88, 26)
	o.time:SetParent(o.main)
	o.time:SetLayer(2)

	o.relation = UI.CreateFrame("Text", "Super Meter Relation Frame", o.main)
	o.relation:SetParent(o.main)
	o.relation:SetLayer(2)

	o.mode1 = UI.CreateFrame("Text", "Super Meter Combat Mode 1", o.main)
	o.mode1:SetPoint("TOPCENTER", o.main, "TOPRIGHT", -78, 26)
	o.mode1:SetParent(o.main)
	o.mode1:SetLayer(2)

	o.mode2 = UI.CreateFrame("Text", "Super Meter Combat Mode 2", o.main)
	o.mode2:SetPoint("TOPCENTER", o.main, "TOPRIGHT", -28, 26)
	o.mode2:SetParent(o.main)
	o.mode2:SetLayer(2)

	o.mainslider = UI.CreateFrame("RiftScrollbar", "Super Meter Combat Slider", o.main)
	o.mainslider:SetPoint("CENTERLEFT", o.main, "CENTERLEFT", -20, 0)
	o.mainslider:SetParent(o.main)
	o.mainslider:SetVisible(false)

	o.menus = UI.CreateFrame("Frame", "Super Meter Menu", o.main)
	o.menus:SetBackgroundColor(0, 0, 0, 0.88)
	o.menus:SetVisible(false)
	o.menus:SetParent(o.main)
	o.menus:SetHeight(48)
	o.menus:SetWidth(110)
	o.menus:SetLayer(20)

	o.menusbg = UI.CreateFrame("Frame", "Super Meter Menu Background", o.main)
	o.menusbg:SetPoint("TOPCENTER", o.menus, "TOPCENTER", 0, 3)
	o.menusbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.menusbg:SetParent(o.menus)
	o.menusbg:SetHeight(42)
	o.menusbg:SetWidth(104)
	o.menusbg:SetLayer(22)

	o.slots = UI.CreateFrame("Text", "Super Meter Menu Slots", o.main)
	o.slots:SetParent(o.menusbg)
	o.slots:SetHeight(24)
	o.slots:SetLayer(24)

	o.last = UI.CreateFrame("Text", "Super Meter Menu last", o.main)
	o.last:SetParent(o.menusbg)
	o.last:SetHeight(24)
	o.last:SetLayer(24)

	o.index = UI.CreateFrame("Text", "Super Meter Menu Index", o.main)
	o.index:SetParent(o.menusbg)
	o.index:SetHeight(24)
	o.index:SetLayer(24)

	o.next = UI.CreateFrame("Text", "Super Meter Menu Next", o.main)
	o.next:SetParent(o.menusbg)
	o.next:SetHeight(24)
	o.next:SetLayer(24)

	o.modeselectbg = UI.CreateFrame("Frame", "Super Meter Mode Select Background", o.main)
	o.modeselectbg:SetBackgroundColor(0, 0, 0, 0.8)
	o.modeselectbg:SetParent(o.main)
	o.modeselectbg:SetVisible(false)
	o.modeselectbg:SetWidth(146)
	o.modeselectbg:SetLayer(8)

	o.modeselect = UI.CreateFrame("Frame", "Super Meter Mode Select Main", o.main)
	o.modeselect:SetPoint("TOPCENTER", o.modeselectbg, "TOPCENTER", 0, 4.88)
	o.modeselect:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.modeselect:SetParent(o.modeselectbg)
	o.modeselect:SetWidth(136)
	o.modeselect:SetLayer(10)

	o.mode1select = UI.CreateFrame("Text", "Super Meter Mode Select 1", o.main)
	o.mode1select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 0)
	o.mode1select:SetParent(o.modeselect)
	o.mode1select:SetHeight(20)
	o.mode1select:SetLayer(12)

	o.mode2select = UI.CreateFrame("Text", "Super Meter Mode Select 2", o.main)
	o.mode2select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 20)
	o.mode2select:SetParent(o.modeselect)
	o.mode2select:SetHeight(20)
	o.mode2select:SetLayer(12)

	o.mode3select = UI.CreateFrame("Text", "Super Meter Mode Select 3", o.main)
	o.mode3select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 40)
	o.mode3select:SetParent(o.modeselect)
	o.mode3select:SetHeight(20)
	o.mode3select:SetLayer(12)

	o.mode4select = UI.CreateFrame("Text", "Super Meter Mode Select 4", o.main)
	o.mode4select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", -0.8, 60)
	o.mode4select:SetParent(o.modeselect)
	o.mode4select:SetHeight(20)
	o.mode4select:SetLayer(12)

	o.mode5select = UI.CreateFrame("Text", "Super Meter Mode Select 5", o.main)
	o.mode5select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 80)
	o.mode5select:SetParent(o.modeselect)
	o.mode5select:SetHeight(20)
	o.mode5select:SetLayer(12)

	o.mode6select = UI.CreateFrame("Text", "Super Meter Mode Select 6", o.main)
	o.mode6select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 100)
	o.mode6select:SetParent(o.modeselect)
	o.mode6select:SetHeight(20)
	o.mode6select:SetLayer(12)

	o.mode7select = UI.CreateFrame("Text", "Super Meter Mode Select 7", o.main)
	o.mode7select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 120)
	o.mode7select:SetParent(o.modeselect)
	o.mode7select:SetHeight(20)
	o.mode7select:SetLayer(12)

	o.mode8select = UI.CreateFrame("Text", "Super Meter Mode Select 8", o.main)
	o.mode8select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 140)
	o.mode8select:SetParent(o.modeselect)
	o.mode8select:SetHeight(20)
	o.mode8select:SetLayer(12)

	o.mode9select = UI.CreateFrame("Text", "Super Meter Mode Select 9", o.main)
	o.mode9select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 160)
	o.mode9select:SetParent(o.modeselect)
	o.mode9select:SetHeight(20)
	o.mode9select:SetLayer(12)

	o.mode10select = UI.CreateFrame("Text", "Super Meter Mode Select 10", o.main)
	o.mode10select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 180)
	o.mode10select:SetParent(o.modeselect)
	o.mode10select:SetHeight(20)
	o.mode10select:SetLayer(12)

	o.mode11select = UI.CreateFrame("Text", "Super Meter Mode Select 11", o.main)
	o.mode11select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 200)
	o.mode11select:SetParent(o.modeselect)
	o.mode11select:SetHeight(20)
	o.mode11select:SetLayer(12)

	o.mode12select = UI.CreateFrame("Text", "Super Meter Mode Select 12", o.main)
	o.mode12select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0.2, 220)
	o.mode12select:SetParent(o.modeselect)
	o.mode12select:SetHeight(20)
	o.mode12select:SetLayer(12)

	o.mode13select = UI.CreateFrame("Text", "Super Meter Mode Select 13", o.main)
	o.mode13select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 240)
	o.mode13select:SetParent(o.modeselect)
	o.mode13select:SetHeight(20)
	o.mode13select:SetLayer(12)

	o.mode14select = UI.CreateFrame("Text", "Super Meter Mode Select 14", o.main)
	o.mode14select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0.4, 260)
	o.mode14select:SetParent(o.modeselect)
	o.mode14select:SetHeight(20)
	o.mode14select:SetLayer(12)

	o.combatmask1 = UI.CreateFrame("Mask", "Super Meter Combat Mask 1", o.main)
	o.combatmask1:SetPoint("BOTTOMLEFT", o.main, "BOTTOMLEFT", 4, -26)
	o.combatmask1:SetWidth(SuperMeter_width - 108)
	o.combatmask1:SetParent(o.main)
	o.combatmask1:SetLayer(2)

	o.combatmask2 = UI.CreateFrame("Mask", "Super Meter Combat Mask 2", o.main)
	o.combatmask2:SetPoint("CENTERRIGHT", o.combatmask1, "CENTERRIGHT", 50, 0)
	o.combatmask2:SetParent(o.main)
	o.combatmask2:SetWidth(48)
	o.combatmask2:SetLayer(2)

	o.combatmask3 = UI.CreateFrame("Mask", "Super Meter Combat Mask 3", o.main)
	o.combatmask3:SetPoint("CENTERRIGHT", o.combatmask2, "CENTERRIGHT", 50, 0)
	o.combatmask3:SetParent(o.main)
	o.combatmask3:SetWidth(48)
	o.combatmask3:SetLayer(2)

	o.combattext1 = UI.CreateFrame("Text", "Super Meter Combat Text 1", o.main)
	o.combattext1:SetPoint("TOPLEFT", o.combatmask1, "TOPLEFT", 0, -trim)
	o.combattext1:SetParent(o.combatmask1)
	o.combattext1:SetLayer(6)

	o.combattext2 = UI.CreateFrame("Text", "Super Meter Combat Text 2", o.main)
	o.combattext2:SetPoint("TOPLEFT", o.combatmask2, "TOPLEFT", 0, -trim)
	o.combattext2:SetParent(o.combatmask2)
	o.combattext2:SetWidth(42)
	o.combattext2:SetLayer(6)

	o.combattext3 = UI.CreateFrame("Text", "Super Meter Combat Text 3", o.main)
	o.combattext3:SetPoint("TOPLEFT", o.combatmask3, "TOPLEFT", 0, -trim)
	o.combattext3:SetParent(o.combatmask3)
	o.combattext3:SetWidth(42)
	o.combattext3:SetLayer(6)

	o.unitbar1 = UI.CreateFrame("Text", "Super Meter Unit Bar 1", o.main)
	o.unitbar1:SetParent(o.combatmask1)
	o.unitbar1:SetLayer(4)

	o.unitbar2 = UI.CreateFrame("Text", "Super Meter Unit Bar 2", o.main)
	o.unitbar2:SetParent(o.combatmask1)
	o.unitbar2:SetLayer(4)

	o.unitbar3 = UI.CreateFrame("Text", "Super Meter Unit Bar 3", o.main)
	o.unitbar3:SetParent(o.combatmask1)
	o.unitbar3:SetLayer(4)

	o.unitbar4 = UI.CreateFrame("Text", "Super Meter Unit Bar 4", o.main)
	o.unitbar4:SetParent(o.combatmask1)
	o.unitbar4:SetLayer(4)

	o.unitbar5 = UI.CreateFrame("Text", "Super Meter Unit Bar 5", o.main)
	o.unitbar5:SetParent(o.combatmask1)
	o.unitbar5:SetLayer(4)

	o.unitbar6 = UI.CreateFrame("Text", "Super Meter Unit Bar 6", o.main)
	o.unitbar6:SetParent(o.combatmask1)
	o.unitbar6:SetLayer(4)

	o.unitbar7 = UI.CreateFrame("Text", "Super Meter Unit Bar 7", o.main)
	o.unitbar7:SetParent(o.combatmask1)
	o.unitbar7:SetLayer(4)

	o.unitbar8 = UI.CreateFrame("Text", "Super Meter Unit Bar 8", o.main)
	o.unitbar8:SetParent(o.combatmask1)
	o.unitbar8:SetLayer(4)

	o.unitbar9 = UI.CreateFrame("Text", "Super Meter Unit Bar 9", o.main)
	o.unitbar9:SetParent(o.combatmask1)
	o.unitbar9:SetLayer(4)

	o.unitbar10 = UI.CreateFrame("Text", "Super Meter Unit Bar 10", o.main)
	o.unitbar10:SetParent(o.combatmask1)
	o.unitbar10:SetLayer(4)

	o.unitbar11 = UI.CreateFrame("Text", "Super Meter Unit Bar 11", o.main)
	o.unitbar11:SetParent(o.combatmask1)
	o.unitbar11:SetLayer(4)

	o.unitbar12 = UI.CreateFrame("Text", "Super Meter Unit Bar 12", o.main)
	o.unitbar12:SetParent(o.combatmask1)
	o.unitbar12:SetLayer(4)

	o.unitbar13 = UI.CreateFrame("Text", "Super Meter Unit Bar 13", o.main)
	o.unitbar13:SetParent(o.combatmask1)
	o.unitbar13:SetLayer(4)

	o.unitbar14 = UI.CreateFrame("Text", "Super Meter Unit Bar 14", o.main)
	o.unitbar14:SetParent(o.combatmask1)
	o.unitbar14:SetLayer(4)

	o.unitbar15 = UI.CreateFrame("Text", "Super Meter Unit Bar 15", o.main)
	o.unitbar15:SetParent(o.combatmask1)
	o.unitbar15:SetLayer(4)

	o.unitbar16 = UI.CreateFrame("Text", "Super Meter Unit Bar 16", o.main)
	o.unitbar16:SetParent(o.combatmask1)
	o.unitbar16:SetLayer(4)

	o.unitbar17 = UI.CreateFrame("Text", "Super Meter Unit Bar 17", o.main)
	o.unitbar17:SetParent(o.combatmask1)
	o.unitbar17:SetLayer(4)

	o.unitbar18 = UI.CreateFrame("Text", "Super Meter Unit Bar 18", o.main)
	o.unitbar18:SetParent(o.combatmask1)
	o.unitbar18:SetLayer(4)

	o.unitbar19 = UI.CreateFrame("Text", "Super Meter Unit Bar 19", o.main)
	o.unitbar19:SetParent(o.combatmask1)
	o.unitbar19:SetLayer(4)

	o.unitbar20 = UI.CreateFrame("Text", "Super Meter Unit Bar 20", o.main)
	o.unitbar20:SetParent(o.combatmask1)
	o.unitbar20:SetLayer(4)

	o.unitbar21 = UI.CreateFrame("Text", "Super Meter Unit Bar 21", o.main)
	o.unitbar21:SetParent(o.combatmask1)
	o.unitbar21:SetLayer(4)

	o.unitbar22 = UI.CreateFrame("Text", "Super Meter Unit Bar 22", o.main)
	o.unitbar22:SetParent(o.combatmask1)
	o.unitbar22:SetLayer(4)

	o.unitbar23 = UI.CreateFrame("Text", "Super Meter Unit Bar 23", o.main)
	o.unitbar23:SetParent(o.combatmask1)
	o.unitbar23:SetLayer(4)

	o.unitbar24 = UI.CreateFrame("Text", "Super Meter Unit Bar 24", o.main)
	o.unitbar24:SetParent(o.combatmask1)
	o.unitbar24:SetLayer(4)

	o.unitbar25 = UI.CreateFrame("Text", "Super Meter Unit Bar 25", o.main)
	o.unitbar25:SetParent(o.combatmask1)
	o.unitbar25:SetLayer(4)

	o.unitbar26 = UI.CreateFrame("Text", "Super Meter Unit Bar 26", o.main)
	o.unitbar26:SetParent(o.combatmask1)
	o.unitbar26:SetLayer(4)

	o.unitbar27 = UI.CreateFrame("Text", "Super Meter Unit Bar 27", o.main)
	o.unitbar27:SetParent(o.combatmask1)
	o.unitbar27:SetLayer(4)

	o.unitbar28 = UI.CreateFrame("Text", "Super Meter Unit Bar 28", o.main)
	o.unitbar28:SetParent(o.combatmask1)
	o.unitbar28:SetLayer(4)

	o.combattotal1 = UI.CreateFrame("Mask", "Super Meter Combat Total 1", o.main)
	o.combattotal1:SetPoint("BOTTOMCENTER", o.main, "BOTTOMCENTER", -50, -4)
	o.combattotal1:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.combattotal1:SetWidth(SuperMeter_width - 108)
	o.combattotal1:SetParent(o.main)
	o.combattotal1:SetHeight(19)
	o.combattotal1:SetLayer(2)

	o.combattotal2 = UI.CreateFrame("Mask", "Super Meter Combat Total 2", o.main)
	o.combattotal2:SetPoint("CENTERRIGHT", o.combattotal1, "CENTERRIGHT", 50, 0)
	o.combattotal2:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.combattotal2:SetParent(o.main)
	o.combattotal2:SetHeight(19)
	o.combattotal2:SetWidth(48)
	o.combattotal2:SetLayer(2)

	o.combattotal3 = UI.CreateFrame("Mask", "Super Meter Combat Total 3", o.main)
	o.combattotal3:SetPoint("CENTERRIGHT", o.combattotal2, "CENTERRIGHT", 50, 0)
	o.combattotal3:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.combattotal3:SetParent(o.main)
	o.combattotal3:SetHeight(19)
	o.combattotal3:SetWidth(48)
	o.combattotal3:SetLayer(2)

	o.totaltext1 = UI.CreateFrame("Text", "Super Meter Combat Total Text 1", o.main)
	o.totaltext1:SetParent(o.combattotal1)
	o.totaltext1:SetLayer(4)

	o.totaltext2 = UI.CreateFrame("Text", "Super Meter Combat Total Text 2", o.main)
	o.totaltext2:SetParent(o.combattotal2)
	o.totaltext2:SetWidth(42)
	o.totaltext2:SetLayer(4)

	o.totaltext3 = UI.CreateFrame("Text", "Super Meter Combat Total Text 3", o.main)
	o.totaltext3:SetParent(o.combattotal3)
	o.totaltext3:SetWidth(42)
	o.totaltext3:SetLayer(4)

	o.copy = UI.CreateFrame("RiftTextfield", "Super Meter Copy Text", o.main)
	o.copy:SetParent(o.combattotal1)
	o.copy:SetVisible(false)
	o.copy:SetHeight(20.84)
	o.copy:SetLayer(4)

	o.plog = UI.CreateFrame("Frame", "Super Meter Player Logs Main", o.main)
	o.plog:SetPoint("TOPCENTER", UIParent, "TOPCENTER", SuperMeter_logX, SuperMeter_logY)
	o.plog:SetBackgroundColor(0, 0, 0, 0.8)
	o.plog:SetParent(o.main)
	o.plog:SetVisible(false)
	o.plog:SetHeight(308)
	o.plog:SetLayer(8)

	o.plogtitlebg = UI.CreateFrame("Frame", "Super Meter Player Logs Title Background", o.main)
	o.plogtitlebg:SetPoint("TOPCENTER", o.plog, "TOPCENTER", 0, 4)
	o.plogtitlebg:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.plogtitlebg:SetParent(o.plog)
	o.plogtitlebg:SetHeight(48)
	o.plogtitlebg:SetLayer(10)

	o.plogtitle = UI.CreateFrame("Text", "Super Meter Player Logs Title", o.main)
	o.plogtitle:SetPoint("TOPCENTER", o.plogtitlebg, "TOPCENTER", 0, 0)
	o.plogtitle:SetParent(o.plog)
	o.plogtitle:SetFontSize(16)
	o.plogtitle:SetHeight(24)
	o.plogtitle:SetLayer(12)

	o.plogtitle2 = UI.CreateFrame("Text", "Super Meter Player Logs Secondary Title", o.main)
	o.plogtitle2:SetPoint("TOPCENTER", o.plogtitle, "TOPCENTER", 0, 24)
	o.plogtitle2:SetParent(o.plog)
	o.plogtitle2:SetFontSize(14)
	o.plogtitle2:SetHeight(24)
	o.plogtitle2:SetLayer(12)

	o.plogoutbg = UI.CreateFrame("Frame", "Super Meter Player Logs Output Background", o.main)
	o.plogoutbg:SetPoint("TOPCENTER", o.plog, "TOPCENTER", 0, 56)
	o.plogoutbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.plogoutbg:SetParent(o.plog)
	o.plogoutbg:SetHeight(248)
	o.plogoutbg:SetLayer(10)

	o.plogmask = UI.CreateFrame("Mask", "Super Meter Player Logs Mask", o.main)
	o.plogmask:SetPoint("TOPCENTER", o.plogoutbg, "TOPCENTER", -4, 6)
	o.plogmask:SetParent(o.plog)
	o.plogmask:SetHeight(236)
	o.plogmask:SetLayer(12)

	o.plogtext = UI.CreateFrame("Text", "Super Meter Player Logs Output", o.main)
	o.plogtext:SetFontColor(0.88, 0.48, 0.0)
	o.plogtext:SetParent(o.plogmask)
	o.plogtext:SetFontSize(14)
	o.plogtext:SetLayer(14)

	o.plogslider = UI.CreateFrame("RiftScrollbar", "Super Meter Player Logs Slider", o.main)
	o.plogslider:SetPoint("CENTERLEFT", o.plogmask, "CENTERLEFT", 14, 0)
	o.plogslider:SetParent(o.plogmask)
	o.plogslider:SetVisible(false)
	o.plogslider:SetHeight(236)
	o.plogslider:SetWidth(18)
	o.plogslider:SetLayer(14)

	o.datatip = UI.CreateFrame("Frame", "Super Meter Datatip Main", o.main)
	o.datatip:SetBackgroundColor(0, 0, 0, 2)
	o.datatip:SetParent(o.main)
	o.datatip:SetVisible(false)
	o.datatip:SetLayer(24)

	o.datatiptext = UI.CreateFrame("Text", "Super Meter Datatip Text", o.main)
	o.datatiptext:SetPoint("TOPLEFT", o.datatip, "TOPLEFT", 8, 4.88)
	o.datatiptext:SetParent(o.datatip)
	o.datatiptext:SetLayer(26)

	o.infotip = UI.CreateFrame("Frame", "Super Meter Infotip Main", o.main)
	o.infotip:SetBackgroundColor(0, 0, 0, 2)
	o.infotip:SetParent(o.main)
	o.infotip:SetVisible(false)
	o.infotip:SetLayer(24)

	o.infotiptext = UI.CreateFrame("Text", "Super Meter Infotip Text", o.main)
	o.infotiptext:SetPoint("TOPLEFT", o.infotip, "TOPLEFT", 8, 4.88)
	o.infotiptext:SetParent(o.infotip)
	o.infotiptext:SetLayer(26)

	o.tipbg = UI.CreateFrame("Frame", "Super Meter Tooltip Background", o.main)
	o.tipbg:SetPoint("BOTTOMRIGHT", o.datatip, "BOTTOMRIGHT", 1, 1)
	o.tipbg:SetParent(o.main)
	o.tipbg:SetVisible(false)
	o.tipbg:SetLayer(22)

	o.tipmv = UI.CreateFrame("Frame", "Super Meter Tooltip Move Frame", o.main)
	o.tipmv:SetPoint("TOPRIGHT", o.tipbg, "TOPRIGHT", 0, 0)
	o.tipmv:SetParent(o.main)
	o.tipmv:SetVisible(false)
	o.tipmv:SetLayer(20)

	o.smgrm = UI.CreateFrame("Frame", "Super Meter Session Manager Main", o.main)
	o.smgrm:SetPoint("CENTER", UIParent, "CENTER", 0, -108)
	o.smgrm:SetBackgroundColor(0, 0, 0, 0.8)
	o.smgrm:SetParent(o.main)
	o.smgrm:SetVisible(false)
	o.smgrm:SetHeight(484)
	o.smgrm:SetWidth(760)
	o.smgrm:SetLayer(8)

	o.smgrmbg = UI.CreateFrame("Frame", "Super Meter Session Manager Main Background", o.main)
	o.smgrmbg:SetPoint("TOPCENTER", o.smgrm, "TOPCENTER", 0, 60)
	o.smgrmbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smgrmbg:SetParent(o.smgrm)
	o.smgrmbg:SetHeight(414)
	o.smgrmbg:SetWidth(740)
	o.smgrmbg:SetLayer(10)

	o.smgrtbh = UI.CreateFrame("Frame", "Super Meter Session Manager Title Background", o.main)
	o.smgrtbh:SetPoint("TOPCENTER", o.smgrm, "TOPCENTER", 0, 10)
	o.smgrtbh:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.smgrtbh:SetParent(o.smgrm)
	o.smgrtbh:SetWidth(740)
	o.smgrtbh:SetLayer(12)

	o.smgrt = UI.CreateFrame("Text", "Super Meter Session Manager Title", o.main)
	o.smgrt:SetPoint("TOPCENTER", o.smgrm, "TOPCENTER", 0, 14.8)
	o.smgrt:SetParent(o.smgrm)
	o.smgrt:SetFontSize(20)
	o.smgrt:SetLayer(14)

	o.smgrcm = UI.CreateFrame("Mask", "Super Meter Session Manager Current Mask", o.main)
	o.smgrcm:SetPoint("TOPLEFT", o.smgrmbg, "TOPLEFT", 12, 46)
	o.smgrcm:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smgrcm:SetParent(o.smgrm)
	o.smgrcm:SetHeight(302)
	o.smgrcm:SetWidth(350)
	o.smgrcm:SetLayer(14)

	o.smgrsm = UI.CreateFrame("Mask", "Super Meter Session Manager Saved Mask", o.main)
	o.smgrsm:SetPoint("TOPRIGHT", o.smgrmbg, "TOPRIGHT", -12, 46)
	o.smgrsm:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smgrsm:SetParent(o.smgrm)
	o.smgrsm:SetHeight(302)
	o.smgrsm:SetWidth(350)
	o.smgrsm:SetLayer(14)

	o.smgrctbg = UI.CreateFrame("Mask", "Super Meter Current Session Title Background", o.main)
	o.smgrctbg:SetPoint("TOPCENTER", o.smgrcm, "TOPCENTER", 0, -36)
	o.smgrctbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smgrctbg:SetParent(o.smgrm)
	o.smgrctbg:SetHeight(24)
	o.smgrctbg:SetWidth(350)
	o.smgrctbg:SetLayer(14)

	o.smgrstbg = UI.CreateFrame("Mask", "Super Meter Saved Session Title Background", o.main)
	o.smgrstbg:SetPoint("TOPCENTER", o.smgrsm, "TOPCENTER", 0, -36)
	o.smgrstbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smgrstbg:SetParent(o.smgrm)
	o.smgrstbg:SetHeight(24)
	o.smgrstbg:SetWidth(350)
	o.smgrstbg:SetLayer(14)

	o.smgrct = UI.CreateFrame("Text", "Super Meter Current Session Title", o.main)
	o.smgrct:SetPoint("TOPCENTER", o.smgrctbg, "TOPCENTER", 0, 0)
	o.smgrct:SetParent(o.smgrctbg)
	o.smgrct:SetFontSize(16)
	o.smgrct:SetLayer(16)

	o.smgrst = UI.CreateFrame("Text", "Super Meter Saved Session Title", o.main)
	o.smgrst:SetPoint("TOPCENTER", o.smgrstbg, "TOPCENTER", 0, 0)
	o.smgrst:SetParent(o.smgrstbg)
	o.smgrst:SetFontSize(16)
	o.smgrst:SetLayer(16)

	o.smgrc = UI.CreateFrame("Text", "Super Meter Session Manager Current Text", o.main)
	o.smgrc:SetPoint("TOPRIGHT", o.smgrcm, "TOPRIGHT", 0, 0)
	o.smgrc:SetParent(o.smgrcm)
	o.smgrc:SetFontSize(14)
	o.smgrc:SetWidth(320)
	o.smgrc:SetLayer(16)

	o.smgrs = UI.CreateFrame("Text", "Super Meter Session Manager Saved Text", o.main)
	o.smgrs:SetPoint("TOPRIGHT", o.smgrsm, "TOPRIGHT", 0, 0)
	o.smgrs:SetParent(o.smgrsm)
	o.smgrs:SetFontSize(14)
	o.smgrs:SetWidth(320)
	o.smgrs:SetLayer(16)

	o.smgrcs = UI.CreateFrame("RiftScrollbar", "Super Meter Session Manager Current Slider", o.main)
	o.smgrcs:SetPoint("CENTERLEFT", o.smgrcm, "CENTERLEFT", 6.8, 0)
	o.smgrcs:SetParent(o.smgrcm)
	o.smgrcs:SetVisible(false)
	o.smgrcs:SetHeight(298)
	o.smgrcs:SetWidth(18)
	o.smgrcs:SetLayer(16)

	o.smgrss = UI.CreateFrame("RiftScrollbar", "Super Meter Session Manager Saved Slider", o.main)
	o.smgrss:SetPoint("CENTERLEFT", o.smgrsm, "CENTERLEFT", 6.8, 0)
	o.smgrss:SetParent(o.smgrsm)
	o.smgrss:SetVisible(false)
	o.smgrss:SetHeight(298)
	o.smgrss:SetWidth(18)
	o.smgrss:SetLayer(16)

	o.smgrp = UI.CreateFrame("Frame", "Super Meter Session Manager Panel", o.main)
	o.smgrp:SetPoint("BOTTOMCENTER", o.smgrmbg, "BOTTOMCENTER", 0, -12)
	o.smgrp:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smgrp:SetParent(o.smgrm)
	o.smgrp:SetWidth(716)
	o.smgrp:SetLayer(14)

	o.smgre = UI.CreateFrame("RiftButton", "Super Meter Session Manager Export", o.main)
	o.smgre:SetPoint("LEFTCENTER", o.smgrp, "LEFTCENTER", 40, 0.2)
	o.smgre:SetParent(o.smgrm)
	o.smgre:SetWidth(122)
	o.smgre:SetLayer(16)

	o.smgrv = UI.CreateFrame("RiftButton", "Super Meter Session Manager View", o.main)
	o.smgrv:SetPoint("CENTER", o.smgrp, "CENTER", -86, 0.2)
	o.smgrv:SetParent(o.smgrm)
	o.smgrv:SetWidth(122)
	o.smgrv:SetLayer(16)

	o.smgrr = UI.CreateFrame("RiftButton", "Super Meter Session Manager Rename", o.main)
	o.smgrr:SetPoint("CENTER", o.smgrp, "CENTER", 86, 0.2)
	o.smgrr:SetParent(o.smgrm)
	o.smgrr:SetWidth(122)
	o.smgrr:SetLayer(16)

	o.smgrd = UI.CreateFrame("RiftButton", "Super Meter Session Manager Delete", o.main)
	o.smgrd:SetPoint("RIGHTCENTER", o.smgrp, "RIGHTCENTER", -40, 0.2)
	o.smgrd:SetParent(o.smgrm)
	o.smgrd:SetWidth(122)
	o.smgrd:SetLayer(16)

	o.smnbd = UI.CreateFrame("Frame", "Super Meter Session Manager Name Border", o.main)
	o.smnbd:SetPoint("LEFTCENTER", o.smgrp, "LEFTCENTER", 11, 0.08)
	o.smnbd:SetBackgroundColor(0, 0, 0, 0.2)
	o.smnbd:SetParent(o.smgrm)
	o.smnbd:SetVisible(false)
	o.smnbd:SetHeight(26.88)
	o.smnbd:SetWidth(326)
	o.smnbd:SetLayer(16)

	o.smname = UI.CreateFrame("RiftTextfield", "Super Meter Session Manager Name", o.main)
	o.smname:SetPoint("LEFTCENTER", o.smgrp, "LEFTCENTER", 15, 0.08)
	o.smname:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smname:SetParent(o.smgrm)
	o.smname:SetVisible(false)
	o.smname:SetHeight(18.88)
	o.smname:SetWidth(318)
	o.smname:SetLayer(18)

	o.cmd = UI.CreateContext("Context")
	o.cmd:SetPoint("LEFTCENTER", UIParent, "LEFTCENTER", 8, -68)
	o.cmd:SetBackgroundColor(0, 0, 0, 0.8)
	o.cmd:SetVisible(false)
	o.cmd:SetHeight(456)
	o.cmd:SetWidth(160)
	o.cmd:SetLayer(8)

	o.cmdbg = UI.CreateFrame("Frame", "Super Meter Options Backgroud", o.cmd)
	o.cmdbg:SetPoint("CENTER", o.cmd, "CENTER", 0, 0)
	o.cmdbg:SetBackgroundColor(0, 0.4, 0.8, 0.12)
	o.cmdbg:SetParent(o.cmd)
	o.cmdbg:SetHeight(440)
	o.cmdbg:SetWidth(142)
	o.cmdbg:SetLayer(10)

	o.cmdconverter = UI.CreateFrame("RiftButton", "Super Meter Options Converter", o.cmd)
	o.cmdconverter:SetPoint("TOPCENTER", o.cmdbg, "TOPCENTER", 0, 3.28)
	o.cmdconverter:SetParent(o.cmd)
	o.cmdconverter:SetWidth(128)
	o.cmdconverter:SetLayer(12)

	o.cmdfull = UI.CreateFrame("RiftButton", "Super Meter Options Full", o.cmd)
	o.cmdfull:SetPoint("TOPCENTER", o.cmdconverter, "TOPCENTER", 0, 28)
	o.cmdfull:SetParent(o.cmd)
	o.cmdfull:SetWidth(128)
	o.cmdfull:SetLayer(12)

	o.cmdgroup = UI.CreateFrame("RiftButton", "Super Meter Options Group", o.cmd)
	o.cmdgroup:SetPoint("TOPCENTER", o.cmdfull, "TOPCENTER", 0, 28)
	o.cmdgroup:SetParent(o.cmd)
	o.cmdgroup:SetWidth(128)
	o.cmdgroup:SetLayer(12)

	o.cmdmouseover = UI.CreateFrame("RiftButton", "Super Meter Options Mouseover", o.cmd)
	o.cmdmouseover:SetPoint("TOPCENTER", o.cmdgroup, "TOPCENTER", 0, 28)
	o.cmdmouseover:SetParent(o.cmd)
	o.cmdmouseover:SetWidth(128)
	o.cmdmouseover:SetLayer(12)

	o.cmdperformance = UI.CreateFrame("RiftButton", "Super Meter Options Performance", o.cmd)
	o.cmdperformance:SetPoint("TOPCENTER", o.cmdmouseover, "TOPCENTER", 0, 28)
	o.cmdperformance:SetParent(o.cmd)
	o.cmdperformance:SetWidth(128)
	o.cmdperformance:SetLayer(12)

	o.cmdlog = UI.CreateFrame("RiftButton", "Super Meter Options Log", o.cmd)
	o.cmdlog:SetPoint("TOPCENTER", o.cmdperformance, "TOPCENTER", 0, 28)
	o.cmdlog:SetParent(o.cmd)
	o.cmdlog:SetWidth(128)
	o.cmdlog:SetLayer(12)

	o.cmdself = UI.CreateFrame("RiftButton", "Super Meter Options Self", o.cmd)
	o.cmdself:SetPoint("TOPCENTER", o.cmdlog, "TOPCENTER", 0, 28)
	o.cmdself:SetParent(o.cmd)
	o.cmdself:SetWidth(128)
	o.cmdself:SetLayer(12)

	o.cmdunify = UI.CreateFrame("RiftButton", "Super Meter Options unify", o.cmd)
	o.cmdunify:SetPoint("TOPCENTER", o.cmdself, "TOPCENTER", 0, 28)
	o.cmdunify:SetParent(o.cmd)
	o.cmdunify:SetWidth(128)
	o.cmdunify:SetLayer(12)

	o.cmdrank = UI.CreateFrame("RiftButton", "Super Meter Options Rank", o.cmd)
	o.cmdrank:SetPoint("TOPCENTER", o.cmdunify, "TOPCENTER", 0, 28)
	o.cmdrank:SetParent(o.cmd)
	o.cmdrank:SetWidth(128)
	o.cmdrank:SetLayer(12)

	o.cmdalpha = UI.CreateFrame("RiftButton", "Super Meter Options Alpha", o.cmd)
	o.cmdalpha:SetPoint("TOPCENTER", o.cmdrank, "TOPCENTER", 0, 40)
	o.cmdalpha:SetParent(o.cmd)
	o.cmdalpha:SetWidth(128)
	o.cmdalpha:SetLayer(12)

	o.cmdtoggle = UI.CreateFrame("RiftButton", "Super Meter Options Toggle", o.cmd)
	o.cmdtoggle:SetPoint("TOPCENTER", o.cmdalpha, "TOPCENTER", 0, 28)
	o.cmdtoggle:SetParent(o.cmd)
	o.cmdtoggle:SetWidth(128)
	o.cmdtoggle:SetLayer(12)

	o.cmdhelp = UI.CreateFrame("RiftButton", "Super Meter Options Help", o.cmd)
	o.cmdhelp:SetPoint("TOPCENTER", o.cmdtoggle, "TOPCENTER", 0, 40)
	o.cmdhelp:SetParent(o.cmd)
	o.cmdhelp:SetWidth(128)
	o.cmdhelp:SetLayer(12)

	o.cmdswitch = UI.CreateFrame("RiftButton", "Super Meter Options Switch", o.cmd)
	o.cmdswitch:SetPoint("TOPCENTER", o.cmdhelp, "TOPCENTER", 0, 40)
	o.cmdswitch:SetParent(o.cmd)
	o.cmdswitch:SetWidth(128)
	o.cmdswitch:SetLayer(12)

	o.cmdreset = UI.CreateFrame("RiftButton", "Super Meter Options Reset", o.cmd)
	o.cmdreset:SetPoint("TOPCENTER", o.cmdswitch, "TOPCENTER", 0, 28)
	o.cmdreset:SetParent(o.cmd)
	o.cmdreset:SetWidth(128)
	o.cmdreset:SetLayer(12)

	function o.main.Event:WheelBack()
		if SuperMeter_scroll and SuperMeter_interval then
			if o.combattext1:GetHeight() > o.combatmask1:GetHeight() then
				o.mainslider:Nudge(SuperMeter_interval)
			end
		end
	end

	function o.main.Event:WheelForward()
		if SuperMeter_scroll and SuperMeter_interval then
			if o.combattext1:GetHeight() > o.combatmask1:GetHeight() then
				o.mainslider:Nudge(-SuperMeter_interval)
			end
		end
	end

	function o.mainslider.Event:ScrollbarChange()
		if SuperMeter_scroll and SuperMeter_interval then
			local offsetY = (o.mainslider:GetPosition() - o.mainslider:GetPosition() * 2) - trim
			o.combattext1:SetPoint("TOPLEFT", o.combatmask1, "TOPLEFT", 0, offsetY)
			o.combattext2:SetPoint("TOPLEFT", o.combatmask2, "TOPLEFT", 0, offsetY)
			o.combattext3:SetPoint("TOPLEFT", o.combatmask3, "TOPLEFT", 0, offsetY)
		end
	end

	function o.title.Event:LeftDown()
		if SuperMeter_sticky then return end
		local mouse = Inspect.Mouse()
		o.state.startY1 = o.main:GetTop()
		o.state.startX1 = SuperMeter_x
		o.state.mouseStartX1 = mouse.x
		o.state.mouseStartY1 = mouse.y
		o.state.mouseDown1 = true
	end

	function o.title.Event:MouseIn()
		o.title:SetEffectGlow(effects)
	end

	function o.title.Event:MouseMove()
		local text = SuperMeter.Tooltip("Main")
		if o.state.mouseDown1 then
			local mouse = Inspect.Mouse()
			SuperMeter_x = mouse.x - o.state.mouseStartX1 + o.state.startX1
			SuperMeter_y = mouse.y - o.state.mouseStartY1 + o.state.startY1
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y)
			o.combatmask1:SetHeight(0)
			o.combatmask2:SetHeight(0)
			o.combatmask3:SetHeight(0)
			o.menus:SetVisible(false)
			o.main:SetHeight(72.8)
			o.TipHide(mouseDown1)
		else
			o.datatipShow(text)
		end
	end

	function o.title.Event:LeftUp()
		o.state.mouseDown1 = false
		o.Display()
	end

	function o.title.Event:MouseOut()
		o.title:SetEffectGlow(disable)
		o.TipHide()
	end

	function o.title.Event:MiddleClick()
		if SuperMeter_fontSize == 14 then
			SuperMeter_fontSize = 13
		else
			SuperMeter_fontSize = 14
		end
		SuperMeter_abilityUnit = false
		o.mainslider:SetRange(0, 0)
		SuperMeter_position = false
		o.datatip:SetVisible(false)
		o.infotip:SetVisible(false)
		SuperMeter_sticky = false
		o.tipbg:SetVisible(false)
		o.Display()
	end

	function o.title.Event:RightClick()
		SuperMeter_growUp = not SuperMeter_growUp
		if o.combattext1:GetHeight() <= 8 then
			if SuperMeter_growUp then
				print(SuperMeter_region20)
			else
				print(SuperMeter_region19)
			end
		end
		o.Display()
	end

	function o.title.Event:WheelBack()
		if SuperMeter_sticky then return end
		if SuperMeter_width <= 240 then return end
		SuperMeter_width = SuperMeter_width - 2
		SuperMeter_x = SuperMeter_x + 1
		SuperMeter.Interface.Display()
	end

	function o.title.Event:WheelForward()
		if SuperMeter_sticky then return end
		if SuperMeter_width >= 288 then return end
		SuperMeter_width = SuperMeter_width + 2
		SuperMeter_x = SuperMeter_x - 1
		SuperMeter.Interface.Display()
	end

	function o.clear.Event:LeftClick()
		o.Reset()
	end

	function o.clear.Event:MouseIn()
		o.clear:SetEffectGlow(effects)
	end

	function o.clear.Event:MouseMove()
		local text = SuperMeter.Tooltip("Clear")
		o.datatipShow(text)
	end

	function o.clear.Event:MouseOut()
		o.clear:SetEffectGlow(disable)
		o.TipHide()
	end

	function o.new.Event:LeftClick()
		if SuperMeter and SuperMeter_combat then
			SuperMeter_split = true
			SuperMeter.Combat()
		end
	end

	function o.new.Event:MouseIn()
		o.new:SetEffectGlow(effects)
	end

	function o.new.Event:MouseMove()
		local text = SuperMeter.Tooltip("New")
		o.datatipShow(text)
	end

	function o.new.Event:MouseOut()
		o.new:SetEffectGlow(disable)
		o.TipHide()
	end

	function o.force.Event:LeftClick()
		SuperMeter_force = true
		SuperMeter.Combat()
	end

	function o.force.Event:MouseIn()
		o.force:SetEffectGlow(effects)
	end

	function o.force.Event:MouseMove()
		local text = SuperMeter.Tooltip("Force")
		o.datatipShow(text)
	end

	function o.force.Event:MouseOut()
		o.force:SetEffectGlow(disable)
		o.TipHide()
	end

	function o.log.Event:LeftClick()
		if SuperMeter_pvp then return end
		SuperMeter.Interface.LogList()
		SuperMeter.Entry()
	end

	function o.log.Event:MouseIn()
		o.log:SetEffectGlow(effects)
	end

	function o.log.Event:MouseMove()
		local text = SuperMeter.Tooltip("Log")
		o.datatipShow(text)
	end

	function o.log.Event:MouseOut()
		o.log:SetEffectGlow(disable)
		o.TipHide()
	end

	function o.help.Event:LeftClick()
		o.Help()
	end

	function o.help.Event:MouseIn()
		o.help:SetEffectGlow(effects)
	end

	function o.help.Event:MouseMove()
		local text = SuperMeter.Tooltip("Help")
		o.datatipShow(text)
	end

	function o.help.Event:MouseOut()
		o.help:SetEffectGlow(disable)
		o.TipHide()
	end

	function o.menu.Event:LeftClick()
		o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_menuX, SuperMeter_menuY)
		o.menus:SetVisible(not o.menus:GetVisible())
		o.last:SetText("< ")
		o.next:SetText(" >")
	end

	function o.menu.Event:RightClick()
		o.smgrm:SetVisible(not o.smgrm:GetVisible())
		SuperMeter_exported = false
		SuperMeter_sessions = false
		o.smgre:SetEnabled(false)
		o.smgrv:SetEnabled(false)
		o.smgrr:SetEnabled(false)
		o.smgrd:SetEnabled(false)
		o.smgrcs:SetRange(0, 0)
		o.smgrss:SetRange(0, 0)
		o.Manager()
	end

	function o.menu.Event:MiddleClick()
		SuperMeter_menuX = o.main:GetLeft()
		SuperMeter_menuY = o.main:GetTop() + 24
		o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_menuX, SuperMeter_menuY)
	end

	function o.menu.Event:MouseIn()
		o.menu:SetEffectGlow(effects)
	end

	function o.menu.Event:MouseOut()
		o.menu:SetEffectGlow(disable)
	end

	function o.menusbg.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.startX2 = SuperMeter_menuX
		o.state.startY2 = SuperMeter_menuY
		o.state.mouseStartX2 = mouse.x
		o.state.mouseStartY2 = mouse.y
		o.state.mouseDown2 = true
	end

	function o.menusbg.Event:MouseMove()
		if o.state.mouseDown2 then
			local mouse = Inspect.Mouse()
			SuperMeter_menuX = mouse.x - o.state.mouseStartX2 + o.state.startX2
			SuperMeter_menuY = mouse.y - o.state.mouseStartY2 + o.state.startY2
			o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_menuX, SuperMeter_menuY)
		end
	end

	function o.menusbg.Event:LeftUp()
		o.state.mouseDown2 = false
	end

	function o.slots.Event:LeftClick()
		o.Cycle("cycle")
	end

	function o.slots.Event:MouseIn()
		o.slots:SetEffectGlow(effects)
	end

	function o.slots.Event:MouseOut()
		o.slots:SetEffectGlow(disable)
	end

	function o.slots.Event:WheelBack()
		o.Cycle("mouse-")
	end

	function o.slots.Event:WheelForward()
		o.Cycle("mouse+")
	end

	function o.last.Event:LeftClick()
		if SuperMeter.Offset < #SuperMeter.Sessions - 1 then
			SuperMeter.Offset = SuperMeter.Offset + 1
			o.Change()
		end
	end

	function o.last.Event:MouseIn()
		o.last:SetEffectGlow(effects)
	end

	function o.last.Event:MouseOut()
		o.last:SetEffectGlow(disable)
	end

	function o.index.Event:LeftClick()
		SuperMeter_merge = not SuperMeter_merge
		if not SuperMeter_merge and SuperMeter.Session(true).merge then
			table.remove(SuperMeter.Sessions, #SuperMeter.Sessions)
		end
		if SuperMeter_merge and not SuperMeter_combat then
			SuperMeter.Merge()
		end
		if SuperMeter_merge then
			o.index:SetText("ALL")
		end
		o.Manager()
		o.Change()
	end

	function o.index.Event:RightClick()
		o.smgrm:SetVisible(not o.smgrm:GetVisible())
		SuperMeter_exported = false
		SuperMeter_sessions = false
		o.smgre:SetEnabled(false)
		o.smgrv:SetEnabled(false)
		o.smgrr:SetEnabled(false)
		o.smgrd:SetEnabled(false)
		o.smgrcs:SetRange(0, 0)
		o.smgrss:SetRange(0, 0)
		o.Manager()
	end

	function o.index.Event:MouseIn()
		o.index:SetEffectGlow(effects)
	end

	function o.index.Event:MouseOut()
		o.index:SetEffectGlow(disable)
		o.TipHide()
	end

	function o.index.Event:WheelBack()
		if SuperMeter.Offset < #SuperMeter.Sessions - 1 then
			SuperMeter.Offset = SuperMeter.Offset + 1
			o.Change()
		end
	end

	function o.index.Event:WheelForward()
		if SuperMeter.Offset and SuperMeter.Offset > 0 then
			SuperMeter.Offset = SuperMeter.Offset - 1
			o.Change()
		end
	end

	function o.next.Event:LeftClick()
		if SuperMeter.Offset and SuperMeter.Offset > 0 then
			SuperMeter.Offset = SuperMeter.Offset - 1
			o.Change()
		end
	end

	function o.next.Event:MouseIn()
		o.next:SetEffectGlow(effects)
	end

	function o.next.Event:MouseOut()
		o.next:SetEffectGlow(disable)
	end

	function o.time.Event:LeftClick()
		o.Combat()
	end

	function o.time.Event:MouseIn()
		o.time:SetEffectGlow(effects)
	end

	function o.time.Event:MouseOut()
		o.time:SetEffectGlow(disable)
	end

	function o.relation.Event:LeftClick()
		if SuperMeter_side == "Allies" then
			SuperMeter_side = "Enemies"
		else
			SuperMeter_side = "Allies"
		end
		o.mainslider:SetRange(0, 0)
		o.Relation()
		o.Update(2)
	end

	function o.relation.Event:MouseIn()
		o.relation:SetEffectGlow(effects)
	end

	function o.relation.Event:MouseOut()
		o.relation:SetEffectGlow(disable)
	end

	function o.mode1.Event:LeftClick()
		if SuperMeter_mode == SuperMeter_mode1 then return end
		SuperMeter_mode = SuperMeter_mode1
		o.Update(2)
	end

	function o.mode1.Event:RightClick()
		if o.modeselect:GetVisible() then
			SuperMeter_mode1Select = true
			SuperMeter_mode2Select = false
		else
			SuperMeter_mode1Select = false
			SuperMeter_mode2Select = false
		end
		if SuperMeter_growUp and o.main:GetHeight() < 280 then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y - 20 * 14)
			SuperMeter_move = SuperMeter_growUp
		end
		if o.modeselectbg:GetVisible() and SuperMeter_move then
			SuperMeter_move = false
			o.Position()
		end
		o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 0, 24)
		o.modeselectbg:SetVisible(not o.modeselectbg:GetVisible())
		SuperMeter.Mode()
	end

	function o.mode1.Event:MouseIn()
		o.mode1:SetEffectGlow(effects)
	end

	function o.mode1.Event:MouseMove()
		SuperMeter.Describe(true)
	end

	function o.mode1.Event:MouseOut()
		if SuperMeter_value and not SuperMeter_showPlayer then
			o.totaltext1:SetText("Total:")
		elseif not SuperMeter_showPlayer then
			o.totaltext1:SetText("")
		end
		o.mode1:SetEffectGlow(disable)
		SuperMeter_modeDesc = false
	end

	function o.mode2.Event:LeftClick()
		if SuperMeter_mode == SuperMeter_mode2 then return end
		SuperMeter_mode = SuperMeter_mode2
		o.Update(2)
	end

	function o.mode2.Event:RightClick()
		if o.modeselect:GetVisible() then
			SuperMeter_mode1Select = false
			SuperMeter_mode2Select = true
		else
			SuperMeter_mode1Select = false
			SuperMeter_mode2Select = false
		end
		if SuperMeter_growUp and o.main:GetHeight() < 280 then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y - 20 * 14)
			SuperMeter_move = SuperMeter_growUp
		end
		if o.modeselectbg:GetVisible() and SuperMeter_move then
			SuperMeter_move = false
			o.Position()
		end
		o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 50, 24)
		o.modeselectbg:SetVisible(not o.modeselectbg:GetVisible())
		SuperMeter.Mode()
	end

	function o.mode2.Event:MouseIn()
		o.mode2:SetEffectGlow(effects)
	end

	function o.mode2.Event:MouseMove()
		SuperMeter.Describe(false, true)
	end

	function o.mode2.Event:MouseOut()
		if SuperMeter_value and not SuperMeter_showPlayer then
			o.totaltext1:SetText("Total:")
		elseif not SuperMeter_showPlayer then
			o.totaltext1:SetText("")
		end
		o.mode2:SetEffectGlow(disable)
		SuperMeter_modeDesc = false
	end

	function o.mode1select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("DPS")
		o.Update(2)
	end

	function o.mode2select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("DMG")
		o.Update(2)
	end

	function o.mode3select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("DTN")
		o.Update(2)
	end

	function o.mode4select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("OKL")
		o.Update(2)
	end

	function o.mode5select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("HPS")
		o.Update(2)
	end

	function o.mode6select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("HLG")
		o.Update(2)
	end

	function o.mode7select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("HTN")
		o.Update(2)
	end

	function o.mode8select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("OPS")
		o.Update(2)
	end

	function o.mode9select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("OHG")
		o.Update(2)
	end

	function o.mode10select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("ASB")
		o.Update(2)
	end

	function o.mode11select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("AVD")
		o.Update(2)
	end

	function o.mode12select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("BLK")
		o.Update(2)
	end

	function o.mode13select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("DFT")
		o.Update(2)
	end

	function o.mode14select.Event:LeftClick()
		o.modeselectbg:SetVisible(false)
		o.Select("MSD")
		o.Update(2)
	end

	function o.modeselectbg.Event:MouseIn()
		o.TipHide()
	end

	function o.modeselectbg.Event:MouseOut()
		o.TipHide()
	end

	function o.mode1select.Event:MouseIn()
		o.mode1select:SetEffectGlow(effects)
	end

	function o.mode2select.Event:MouseIn()
		o.mode2select:SetEffectGlow(effects)
	end

	function o.mode3select.Event:MouseIn()
		o.mode3select:SetEffectGlow(effects)
	end

	function o.mode4select.Event:MouseIn()
		o.mode4select:SetEffectGlow(effects)
	end

	function o.mode5select.Event:MouseIn()
		o.mode5select:SetEffectGlow(effects)
	end

	function o.mode6select.Event:MouseIn()
		o.mode6select:SetEffectGlow(effects)
	end

	function o.mode7select.Event:MouseIn()
		o.mode7select:SetEffectGlow(effects)
	end

	function o.mode8select.Event:MouseIn()
		o.mode8select:SetEffectGlow(effects)
	end

	function o.mode9select.Event:MouseIn()
		o.mode9select:SetEffectGlow(effects)
	end

	function o.mode10select.Event:MouseIn()
		o.mode10select:SetEffectGlow(effects)
	end

	function o.mode11select.Event:MouseIn()
		o.mode11select:SetEffectGlow(effects)
	end

	function o.mode12select.Event:MouseIn()
		o.mode12select:SetEffectGlow(effects)
	end

	function o.mode13select.Event:MouseIn()
		o.mode13select:SetEffectGlow(effects)
	end

	function o.mode14select.Event:MouseIn()
		o.mode14select:SetEffectGlow(effects)
	end

	function o.mode1select.Event:MouseOut()
		o.mode1select:SetEffectGlow(disable)
	end

	function o.mode2select.Event:MouseOut()
		o.mode2select:SetEffectGlow(disable)
	end

	function o.mode3select.Event:MouseOut()
		o.mode3select:SetEffectGlow(disable)
	end

	function o.mode4select.Event:MouseOut()
		o.mode4select:SetEffectGlow(disable)
	end

	function o.mode5select.Event:MouseOut()
		o.mode5select:SetEffectGlow(disable)
	end

	function o.mode6select.Event:MouseOut()
		o.mode6select:SetEffectGlow(disable)
	end

	function o.mode7select.Event:MouseOut()
		o.mode7select:SetEffectGlow(disable)
	end

	function o.mode8select.Event:MouseOut()
		o.mode8select:SetEffectGlow(disable)
	end

	function o.mode9select.Event:MouseOut()
		o.mode9select:SetEffectGlow(disable)
	end

	function o.mode10select.Event:MouseOut()
		o.mode10select:SetEffectGlow(disable)
	end

	function o.mode11select.Event:MouseOut()
		o.mode11select:SetEffectGlow(disable)
	end

	function o.mode12select.Event:MouseOut()
		o.mode12select:SetEffectGlow(disable)
	end

	function o.mode13select.Event:MouseOut()
		o.mode13select:SetEffectGlow(disable)
	end

	function o.mode14select.Event:MouseOut()
		o.mode14select:SetEffectGlow(disable)
	end

	function o.combatmask1.Event:LeftClick()
		if SuperMeter_pvp or not SuperMeter_logEnabled then return end
		local unit = SuperMeter.Interface.Unit()
		if unit and unit.combatlog[1] then
			SuperMeter.Interface.LogList()
			SuperMeter.Entry(unit)
		end
	end

	function o.combatmask1.Event:MiddleClick()
		o.Cycle("cycle")
	end

	function o.combatmask1.Event:RightClick()
		if SuperMeter_display == "None" then
			SuperMeter_display = "Bars"
			o.combattext1:SetVisible(true)
		elseif SuperMeter_display == "Bars" then
			SuperMeter_display = "Calling"
			o.combattext1:SetVisible(false)
		elseif SuperMeter_display == "Calling" then
			SuperMeter_display = "None"
			o.combattext1:SetVisible(true)
		end
		o.Display()
	end

	function o.combatmask1.Event:MouseMove()
		if SuperMeter_pvp or not SuperMeter_logEnabled then return end
		local text = SuperMeter.Tooltip("Unit")
		o.datatipShow(text)
	end

	function o.combatmask1.Event:MouseOut()
		o.TipHide()
	end

	function o.combattext2.Event:LeftClick()
		SuperMeter_ModeRequest = SuperMeter_mode1
		SuperMeter_sticky = not SuperMeter_sticky
		o.TipColour(true)
		o.Tooltip(false)
		o.Position()
	end

	function o.combattext2.Event:RightClick()
		SuperMeter_ModeRequest = SuperMeter_mode1
		o.TipColour(true)
		o.Tooltip(true)
		o.Position()
	end

	function o.combattext2.Event:MouseMove()
		if SuperMeter_position or SuperMeter_sticky then return end
		if not SuperMeter_mouseover then return o.TipHide() end
		SuperMeter_ModeRequest = SuperMeter_mode1
		o.TipColour(true)
		o.Tooltip()
	end

	function o.combattext2.Event:MouseOut()
		o.TipHide()
	end

	function o.combattext3.Event:LeftClick()
		SuperMeter_ModeRequest = SuperMeter_mode2
		SuperMeter_sticky = not SuperMeter_sticky
		o.TipColour(true)
		o.Tooltip(false)
		o.Position()
	end

	function o.combattext3.Event:RightClick()
		SuperMeter_ModeRequest = SuperMeter_mode2
		o.TipColour(true)
		o.Tooltip(true)
		o.Position()
	end

	function o.combattext3.Event:MouseMove()
		if SuperMeter_position or SuperMeter_sticky then return end
		if not SuperMeter_mouseover then return o.TipHide() end
		SuperMeter_ModeRequest = SuperMeter_mode2
		o.TipColour(true)
		o.Tooltip()
	end

	function o.combattext3.Event:MouseOut()
		o.TipHide()
	end

	function o.combattotal1.Event:LeftClick()
		SuperMeter_showPlayer = not SuperMeter_showPlayer
		o.Time(false)
		o.Display()
	end

	function o.combattotal1.Event:RightClick()
		SuperMeter_minimal = not SuperMeter_minimal
		o.Time(false)
		o.Display()
	end

	function o.combattotal2.Event:LeftClick()
		if SuperMeter_showPlayer then return end
		o.copy:SetVisible(not o.copy:GetVisible())
		o.totaltext1:SetVisible(not o.copy:GetVisible())
		o.Update(false, "mode1")
	end

	function o.combattotal3.Event:LeftClick()
		if SuperMeter_showPlayer then return end
		o.copy:SetVisible(not o.copy:GetVisible())
		o.totaltext1:SetVisible(not o.copy:GetVisible())
		o.Update(false, "mode2")
	end

	function o.copy.Event:KeyUp()
		o.totaltext1:SetVisible(true)
		o.copy:SetKeyFocus(false)
		o.copy:SetVisible(false)
		o.copy:SetText("")
	end

	function o.plogtitle.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.startX3 = SuperMeter_logX
		o.state.startY3 = SuperMeter_logY
		o.state.mouseStartX3 = mouse.x
		o.state.mouseStartY3 = mouse.y
		o.state.mouseDown3 = true
	end

	function o.plogtitle.Event:MouseMove()
		if o.state.mouseDown3 then
			local mouse = Inspect.Mouse()
			SuperMeter_logX = mouse.x - o.state.mouseStartX3 + o.state.startX3
			SuperMeter_logY = mouse.y - o.state.mouseStartY3 + o.state.startY3
			o.plog:SetPoint("TOPCENTER", UIParent, "TOPCENTER", SuperMeter_logX, SuperMeter_logY)
		end
	end

	function o.plogtitle.Event:LeftUp()
		o.state.mouseDown3 = false
	end

	function o.plogtitle2.Event:LeftClick()
		SuperMeter_table = false
		SuperMeter_unit = false
		SuperMeter.Entry()
	end

	function o.plog.Event:WheelBack()
		if o.plogtext:GetHeight() > o.plogmask:GetHeight() then
			o.plogslider:Nudge(20)
		end
	end

	function o.plog.Event:WheelForward()
		if o.plogtext:GetHeight() > o.plogmask:GetHeight() then
			o.plogslider:Nudge(-20)
		end
	end

	function o.plogtext.Event:LeftClick()
		o.LogEntry(SuperMeter_table)
	end

	function o.plogslider.Event:ScrollbarChange()
		local offsetY = o.plogslider:GetPosition() - o.plogslider:GetPosition() * 2
		o.plogtext:SetPoint("TOPLEFT", o.plogmask, "TOPLEFT", 40, offsetY - 2.8)
	end

	function o.tipmv.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.startX4 = SuperMeter_tipX
		o.state.startY4 = SuperMeter_tipY
		o.state.mouseStartX4 = mouse.x
		o.state.mouseStartY4 = mouse.y
		o.state.mouseDown4 = true
	end

	function o.tipmv.Event:MouseMove()
		local mouse = Inspect.Mouse()
		if mouse and o.state.mouseDown4 then
			SuperMeter_tipX = o.state.mouseStartX4 - mouse.x + o.state.startX4
			SuperMeter_tipY = o.state.mouseStartY4 - mouse.y + o.state.startY4
			o.datatip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -SuperMeter_tipX, -SuperMeter_tipY)
		end
	end

	function o.tipmv.Event:LeftUp()
		o.state.mouseDown4 = false
		o.Position()
	end

	function o.smgrc.Event:LeftClick()
		SuperMeter.Interface.Sessions(true)
		if not SuperMeter_exported and SuperMeter_sessions then
			o.smgrv:SetEnabled(true)
		else
			o.smgrv:SetEnabled(false)
		end
		o.Rename()
	end

	function o.smgrs.Event:LeftClick()
		SuperMeter.Interface.Sessions(false, true)
		if not SuperMeter_exported and SuperMeter_sessions then
			o.smgrv:SetEnabled(true)
		else
			o.smgrv:SetEnabled(false)
		end
		o.Rename()
	end

	function o.smgrcs.Event:ScrollbarChange()
		local offsetY = o.smgrcs:GetPosition() - o.smgrcs:GetPosition() * 2
		o.smgrc:SetPoint("TOPRIGHT", o.smgrcm, "TOPRIGHT", 0, offsetY)
	end

	function o.smgrcm.Event:WheelBack()
		if o.smgrcm:GetHeight() < o.smgrc:GetHeight() then
			o.smgrcs:Nudge(20)
		end
	end

	function o.smgrcm.Event:WheelForward()
		if o.smgrcm:GetHeight() < o.smgrc:GetHeight() then
			o.smgrcs:Nudge(-20)
		end
	end

	function o.smgrss.Event:ScrollbarChange()
		local offsetY = o.smgrss:GetPosition() - o.smgrss:GetPosition() * 2
		o.smgrs:SetPoint("TOPRIGHT", o.smgrsm, "TOPRIGHT", 0, offsetY)
	end

	function o.smgrsm.Event:WheelBack()
		if o.smgrsm:GetHeight() < o.smgrs:GetHeight() then
			o.smgrss:Nudge(20)
		end
	end

	function o.smgrsm.Event:WheelForward()
		if o.smgrsm:GetHeight() < o.smgrs:GetHeight() then
			o.smgrss:Nudge(-20)
		end
	end

	function o.smgre.Event:LeftClick()
		if not o.smgre:GetEnabled() then return end
		if SuperMeter_exported and SuperMeter.Offset > 0 then
			SuperMeter.Offset = SuperMeter.Offset + 1
		end
		if SuperMeter_exported then
			table.insert(SuperMeter.Sessions, SuperMeter_exported)
			SuperMeter_exported = false
		end
		if SuperMeter_sessions then
			table.insert(SuperMeter.Export, SuperMeter_sessions)
			SuperMeter_sessions = false
		end
		o.smgre:SetEnabled(false)
		o.smgrv:SetEnabled(false)
		o.smgrr:SetEnabled(false)
		o.smgrd:SetEnabled(false)
		o.Manager()
		o.Change()
	end

	function o.smgrv.Event:LeftClick()
		if not o.smgrv:GetEnabled() then return end
		for k,v in pairs(SuperMeter.Sessions) do
			if SuperMeter_sessions and v == SuperMeter_sessions then
				SuperMeter.Offset = #SuperMeter.Sessions - k
				SuperMeter.Clean(SuperMeter_view)
				SuperMeter_view = v
			end
		end
		SuperMeter_sessions = false
		o.smgre:SetEnabled(false)
		o.smgrv:SetEnabled(false)
		o.smgrr:SetEnabled(false)
		o.smgrd:SetEnabled(false)
		o.Manager()
		o.Change()
	end

	function o.smgrr.Event:LeftClick()
		if not o.smgrr:GetEnabled() then return end
		if not o.smname:GetVisible() then
			o.smname:SetText("")
			o.Rename(true)
		else
			if SuperMeter_exported then
				SuperMeter_exported.name = o.smname:GetText()
			end
			if SuperMeter_sessions then
				SuperMeter_sessions.name = o.smname:GetText()
			end
			o.Manager()
			o.Rename()
		end
	end

	function o.smgrd.Event:LeftClick()
		if not o.smgrd:GetEnabled() then return end
		if not o.smname:GetVisible() then
			if SuperMeter_sessions then
				for i = 1, #SuperMeter.Sessions do
					if SuperMeter.Sessions[i] == SuperMeter_sessions then
						SuperMeter.Clean(SuperMeter_sessions)
						table.remove(SuperMeter.Sessions, i)
						SuperMeter_sessions = false
					end
				end
			end
			if SuperMeter_exported then
				for i = 1, #SuperMeter.Export do
					if SuperMeter.Export[i] == SuperMeter_exported then
						SuperMeter.Clean(SuperMeter_exported)
						table.remove(SuperMeter.Export, i)
						SuperMeter_exported = false
					end
				end
			end
			if #SuperMeter.Sessions > 1 and SuperMeter.Offset > 0 then
				SuperMeter.Offset = 1
			else
				SuperMeter.Offset = 0
			end
			o.smgre:SetEnabled(false)
			o.smgrv:SetEnabled(false)
			o.smgrr:SetEnabled(false)
			o.smgrd:SetEnabled(false)
		end
		o.ResetTime(false)
		o.Change()
		o.Rename()
	end

	function o.cmdconverter.Event:LeftClick()
		SuperMeter_converter = not SuperMeter_converter
		if SuperMeter_converter then
			print(SuperMeter_region02)
		else
			print(SuperMeter_region01)
		end
	end

	function o.cmdfull.Event:LeftClick()
		SuperMeter_full = not SuperMeter_full
		if SuperMeter_full then
			print(SuperMeter_region04)
		else
			print(SuperMeter_region03)
		end
	end

	function o.cmdgroup.Event:LeftClick()
		SuperMeter_group = not SuperMeter_group
		if SuperMeter_group then
			print(SuperMeter_region06)
		else
			print(SuperMeter_region05)
		end
	end

	function o.cmdmouseover.Event:LeftClick()
		SuperMeter_mouseover = not SuperMeter_mouseover
		if SuperMeter_mouseover then
			print(SuperMeter_region08)
		else
			print(SuperMeter_region07)
		end
		SuperMeter_position = false
		SuperMeter_sticky = false
		o.Position()
		o.TipHide()
	end

	function o.cmdperformance.Event:LeftClick()
		SuperMeter_performance = not SuperMeter_performance
		if SuperMeter_performance then
			SuperMeter_minimal = "true"
			print(SuperMeter_region10)
			SuperMeter_pvp = "true"
		else
			SuperMeter_minimal = false
			print(SuperMeter_region09)
			SuperMeter_pvp = false
		end
		o.Display()
		o.Slots()
	end

	function o.cmdlog.Event:LeftClick()
		SuperMeter_logEnabled = not SuperMeter_logEnabled
		if SuperMeter_logEnabled then
			print(SuperMeter_region12)
		else
			print(SuperMeter_region11)
		end
		o.Display()
	end

	function o.cmdself.Event:LeftClick()
		SuperMeter_self = not SuperMeter_self
		if SuperMeter_self then
			print(SuperMeter_region14)
		else
			print(SuperMeter_region13)
		end
		o.Display()
	end

	function o.cmdunify.Event:LeftClick()
		SuperMeter_unify = not SuperMeter_unify
		if SuperMeter_unify then
			print(SuperMeter_region16)
		else
			print(SuperMeter_region15)
		end
		o.Display()
	end

	function o.cmdrank.Event:LeftClick()
		SuperMeter_rank = not SuperMeter_rank
		if SuperMeter_rank then
			print(SuperMeter_region18)
		else
			print(SuperMeter_region17)
		end
		o.Display()
	end

	function o.cmdalpha.Event:LeftClick()
		if SuperMeter_alpha == 0.8 then
			SuperMeter_alpha = 0.688
		else
			SuperMeter_alpha = 0.8
		end
		o.Display()
	end

	function o.cmdtoggle.Event:LeftClick()
		if not SuperMeter_enabled then return end
		SuperMeter_visible = not SuperMeter_visible
		o.main:SetVisible(SuperMeter_visible)
	end

	function o.cmdhelp.Event:LeftClick()
		o.Help()
	end

	function o.cmdswitch.Event:LeftClick()
		SuperMeter_enabled = not SuperMeter_enabled
		SuperMeter_visible = SuperMeter_enabled
		o.main:SetVisible(SuperMeter_visible)
		o.ResetFrame()
		o.Reset()
	end

	function o.cmdreset.Event:LeftClick()
		SuperMeter_performance = false
		SuperMeter_display = "Calling"
		SuperMeter_logEnabled = true
		SuperMeter_converter = true
		SuperMeter_mouseover = true
		SuperMeter_minimal = false
		SuperMeter_side = "Allies"
		SuperMeter_enabled = true
		SuperMeter_growUp = false
		SuperMeter_visible = true
		SuperMeter_fontSize = 14
		SuperMeter_maxSlots = 10
		SuperMeter_mode1 = "DPS"
		SuperMeter_mode2 = "HPS"
		SuperMeter_full = false
		SuperMeter_group = true
		SuperMeter_unify = true
		SuperMeter_mode = "DPS"
		SuperMeter_rank = true
		SuperMeter_self = true
		SuperMeter_alpha = 0.8
		SuperMeter_menuX = 828
		SuperMeter_menuY = 624
		SuperMeter_tipX = 0.48
		SuperMeter_tipY = 60.0
		SuperMeter_width = 268
		SuperMeter_logX = 0.0
		SuperMeter_logY = 748
		SuperMeter_x = 828
		SuperMeter_y = 600
		o.ResetFrame()
		o.Reset()
	end

	function o.Position()
		local position = SuperMeter_position
		local height = o.main:GetHeight()
		local sticky = SuperMeter_sticky
		local grow = SuperMeter_growUp
		
		if position or sticky then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", o.tipbg:GetLeft() - 2 - o.main:GetWidth(), o.tipbg:GetBottom() - height)
		end
		
		if sticky and o.tipbg:GetWidth() > 600 then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", o.datatip:GetLeft(), o.infotip:GetTop() - 2 - height)
		end
		
		if not sticky and grow then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y - height + 72.8)
		elseif not sticky then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y)
		end
		
		if sticky or position then
			o.tipmv:SetHeight(o.tipbg:GetHeight())
			o.tipmv:SetWidth(o.tipbg:GetWidth())
		end
		
		if not sticky then
			SuperMeter_position = false
			o.tipmv:SetVisible(false)
		else
			SuperMeter_position = true
			o.tipmv:SetVisible(true)
		end
	end

	function o.Time()
		if not SuperMeter_enabled then return end
		if o.state.mouseDown1 then return end
		
		local session = SuperMeter.Session()
		local minimal = SuperMeter_minimal
		local show = SuperMeter_showPlayer
		local time = session.combatTime
		local format = SuperMeter.Time
		local process = string.format
		
		if time and time > 0 then
			local text = process("Time: %0s", format(time))
			
			if not minimal and text:len() > 12 then
				text = format(time)
			end
			
			if minimal and not show then
				o.totaltext1:SetText(text)
			else
				o.time:SetText(text)
			end
		end
	end

	function o.ResetTime()
		o.time:SetText("Time: 00:00")
	end

	function o.Relation()
		local sticky = SuperMeter_sticky
		local side = SuperMeter_side
		
		if side == "Allies" then
			o.relation:SetText("Allies")
			o.combatmask1:SetBackgroundColor(0, 0.8, 0.2, 0.044)
			o.combatmask2:SetBackgroundColor(0, 0.8, 0.2, 0.044)
			o.combatmask3:SetBackgroundColor(0, 0.8, 0.2, 0.044)
			o.mainbg:SetBackgroundColor(0, 0.8, 0.2, 0.044)
		else
			o.relation:SetText("Enemies")
			o.combatmask1:SetBackgroundColor(0.8, 0, 0, 0.044)
			o.combatmask2:SetBackgroundColor(0.8, 0, 0, 0.044)
			o.combatmask3:SetBackgroundColor(0.8, 0, 0, 0.044)
			o.mainbg:SetBackgroundColor(0.8, 0, 0, 0.044)
		end
		
		if sticky then
			SuperMeter_position = false
			SuperMeter_sticky = false
			o.TipHide()
		end
		
		o.TipColour()
	end

	function o.Cycle(change)
		local self = (SuperMeter_maxSlots == 5.02)
		local slots = SuperMeter_maxSlots
		
		if change == "mouse+" then
			if slots == 28 then slots = 4.02 end
			if slots == 5.02 then slots = 1 end
			SuperMeter_maxSlots = slots + 1
		end
		
		if change == "mouse-" then
			if slots == 5.02 then slots = 29 end
			if slots == 2 then slots = 6.02 end
			SuperMeter_maxSlots = slots - 1
		end
		
		if change == "cycle" then
			if slots < 5.00 or self then
				SuperMeter_maxSlots = 5.00
			elseif slots < 10.0 then
				SuperMeter_maxSlots = 10.0
			elseif slots < 20.0 then
				SuperMeter_maxSlots = 20.0
			elseif slots < 28.0 then
				SuperMeter_maxSlots = 28.0
			else
				SuperMeter_maxSlots = 5.02
			end
		end
		
		o.Update(2)
		o.Slots()
	end

	function o.Display(reset)
		local height = SuperMeter.Metrics("height")
		local offset = SuperMeter.Metrics("offset")
		local full = SuperMeter.Metrics("full")
		
		local speed = SuperMeter_performance
		local display = SuperMeter_display
		local show = SuperMeter_logShowing
		local visible = SuperMeter_visible
		local log = SuperMeter_logEnabled
		local export = SuperMeter.Export
		local font = SuperMeter_fontSize
		local warfront = SuperMeter_pvp
		local min = SuperMeter_minimal
		local alpha = SuperMeter_alpha
		local merge = SuperMeter_merge
		local mode1 = SuperMeter_mode1
		local mode2 = SuperMeter_mode2
		local start = SuperMeter_start
		local width = SuperMeter_width
		
		if font then
			o.mode10select:SetFontSize(font)
			o.mode11select:SetFontSize(font)
			o.mode12select:SetFontSize(font)
			o.mode13select:SetFontSize(font)
			o.mode14select:SetFontSize(font)
			o.mode1select:SetFontSize(font)
			o.mode2select:SetFontSize(font)
			o.mode3select:SetFontSize(font)
			o.mode4select:SetFontSize(font)
			o.mode5select:SetFontSize(font)
			o.mode6select:SetFontSize(font)
			o.mode7select:SetFontSize(font)
			o.mode8select:SetFontSize(font)
			o.mode9select:SetFontSize(font)
			o.combattext1:SetFontSize(font)
			o.combattext2:SetFontSize(font)
			o.combattext3:SetFontSize(font)
			o.datatiptext:SetFontSize(font)
			o.infotiptext:SetFontSize(font)
			o.totaltext1:SetFontSize(font)
			o.totaltext2:SetFontSize(font)
			o.totaltext3:SetFontSize(font)
			o.title:SetFontSize(font + 2)
			o.relation:SetFontSize(font)
			o.index:SetFontSize(font)
			o.mode1:SetFontSize(font)
			o.mode2:SetFontSize(font)
			o.slots:SetFontSize(font)
			o.clear:SetFontSize(font)
			o.force:SetFontSize(font)
			o.help:SetFontSize(font)
			o.last:SetFontSize(font)
			o.menu:SetFontSize(font)
			o.next:SetFontSize(font)
			o.time:SetFontSize(font)
			o.log:SetFontSize(font)
			o.new:SetFontSize(font)
		end
		
		if not start and speed then
			SuperMeter_minimal = true
			SuperMeter_pvp = true
			min = speed
		end
		
		if display then
			o.combattext1:SetVisible(true)
		end
		
		if visible then
			o.relation:SetVisible(not min)
			o.clear:SetVisible(not min)
			o.force:SetVisible(not min)
			o.title:SetVisible(not min)
			o.mode1:SetVisible(not min)
			o.mode2:SetVisible(not min)
			o.help:SetVisible(not min)
			o.time:SetVisible(not min)
			o.menu:SetVisible(not min)
			o.log:SetVisible(not min)
			o.new:SetVisible(not min)
		end
		
		if not min then
			o.help:SetVisible(not log)
			o.log:SetVisible(log)
		end
		
		if reset then
			o.title:SetText("Super Meter")
			o.time:SetText("Time: 00:00")
			o.menu:SetText("MENU")
			o.mode1:SetText(mode1)
			o.mode2:SetText(mode2)
			o.force:SetText("F")
			o.clear:SetText("C")
			o.help:SetText("H")
			o.new:SetText("N")
			o.log:SetText("D")
		end
		
		if reset and not merge then
			o.index:SetText("00 - 00")
		end
		
		if reset and merge then
			o.index:SetText("ALL")
		end
		
		if start and speed then
			SuperMeter_pvp = true
			warfront = true
		end
		
		if height and height > 2 then
			o.unitbar1:SetPoint("TOPLEFT", o.combattext1, "TOPLEFT", 0, offset)
			o.unitbar1:SetHeight(height)
			
			o.unitbar2:SetPoint("BOTTOMLEFT", o.unitbar1, "BOTTOMLEFT", 0, full)
			o.unitbar2:SetHeight(height)
			
			o.unitbar3:SetPoint("BOTTOMLEFT", o.unitbar2, "BOTTOMLEFT", 0, full)
			o.unitbar3:SetHeight(height)
			
			o.unitbar4:SetPoint("BOTTOMLEFT", o.unitbar3, "BOTTOMLEFT", 0, full)
			o.unitbar4:SetHeight(height)
			
			o.unitbar5:SetPoint("BOTTOMLEFT", o.unitbar4, "BOTTOMLEFT", 0, full)
			o.unitbar5:SetHeight(height)
			
			o.unitbar6:SetPoint("BOTTOMLEFT", o.unitbar5, "BOTTOMLEFT", 0, full)
			o.unitbar6:SetHeight(height)
			
			o.unitbar7:SetPoint("BOTTOMLEFT", o.unitbar6, "BOTTOMLEFT", 0, full)
			o.unitbar7:SetHeight(height)
			
			o.unitbar8:SetPoint("BOTTOMLEFT", o.unitbar7, "BOTTOMLEFT", 0, full)
			o.unitbar8:SetHeight(height)
			
			o.unitbar9:SetPoint("BOTTOMLEFT", o.unitbar8, "BOTTOMLEFT", 0, full)
			o.unitbar9:SetHeight(height)
			
			o.unitbar10:SetPoint("BOTTOMLEFT", o.unitbar9, "BOTTOMLEFT", 0, full)
			o.unitbar10:SetHeight(height)
			
			o.unitbar11:SetPoint("BOTTOMLEFT", o.unitbar10, "BOTTOMLEFT", 0, full)
			o.unitbar11:SetHeight(height)
			
			o.unitbar12:SetPoint("BOTTOMLEFT", o.unitbar11, "BOTTOMLEFT", 0, full)
			o.unitbar12:SetHeight(height)
			
			o.unitbar13:SetPoint("BOTTOMLEFT", o.unitbar12, "BOTTOMLEFT", 0, full)
			o.unitbar13:SetHeight(height)
			
			o.unitbar14:SetPoint("BOTTOMLEFT", o.unitbar13, "BOTTOMLEFT", 0, full)
			o.unitbar14:SetHeight(height)
			
			o.unitbar15:SetPoint("BOTTOMLEFT", o.unitbar14, "BOTTOMLEFT", 0, full)
			o.unitbar15:SetHeight(height)
			
			o.unitbar16:SetPoint("BOTTOMLEFT", o.unitbar15, "BOTTOMLEFT", 0, full)
			o.unitbar16:SetHeight(height)
			
			o.unitbar17:SetPoint("BOTTOMLEFT", o.unitbar16, "BOTTOMLEFT", 0, full)
			o.unitbar17:SetHeight(height)
			
			o.unitbar18:SetPoint("BOTTOMLEFT", o.unitbar17, "BOTTOMLEFT", 0, full)
			o.unitbar18:SetHeight(height)
			
			o.unitbar19:SetPoint("BOTTOMLEFT", o.unitbar18, "BOTTOMLEFT", 0, full)
			o.unitbar19:SetHeight(height)
			
			o.unitbar20:SetPoint("BOTTOMLEFT", o.unitbar19, "BOTTOMLEFT", 0, full)
			o.unitbar20:SetHeight(height)
			
			o.unitbar22:SetPoint("BOTTOMLEFT", o.unitbar21, "BOTTOMLEFT", 0, full)
			o.unitbar22:SetHeight(height)
			
			o.unitbar23:SetPoint("BOTTOMLEFT", o.unitbar22, "BOTTOMLEFT", 0, full)
			o.unitbar23:SetHeight(height)
			
			o.unitbar24:SetPoint("BOTTOMLEFT", o.unitbar23, "BOTTOMLEFT", 0, full)
			o.unitbar24:SetHeight(height)
			
			o.unitbar25:SetPoint("BOTTOMLEFT", o.unitbar24, "BOTTOMLEFT", 0, full)
			o.unitbar25:SetHeight(height)
			
			o.unitbar26:SetPoint("BOTTOMLEFT", o.unitbar25, "BOTTOMLEFT", 0, full)
			o.unitbar26:SetHeight(height)
			
			o.unitbar27:SetPoint("BOTTOMLEFT", o.unitbar26, "BOTTOMLEFT", 0, full)
			o.unitbar27:SetHeight(height)
			
			o.unitbar28:SetPoint("BOTTOMLEFT", o.unitbar27, "BOTTOMLEFT", 0, full)
			o.unitbar28:SetHeight(height)
		end
		
		if font == 14 then
			o.totaltext1:SetPoint("BOTTOMLEFT", o.combatmask1, "BOTTOMLEFT", 0, 24.2)
			o.totaltext2:SetPoint("BOTTOMLEFT", o.combatmask2, "BOTTOMLEFT", 0, 24.2)
			o.totaltext3:SetPoint("BOTTOMLEFT", o.combatmask3, "BOTTOMLEFT", 0, 24.2)
			o.relation:SetPoint("TOPCENTER", o.main, "TOPCENTER", 0, 26)
			o.title:SetPoint("TOPCENTER", o.main, "TOPCENTER", 0, 2)
		else
			o.totaltext1:SetPoint("BOTTOMLEFT", o.combatmask1, "BOTTOMLEFT", 0, 22.8)
			o.totaltext2:SetPoint("BOTTOMLEFT", o.combatmask2, "BOTTOMLEFT", 0, 22.8)
			o.totaltext3:SetPoint("BOTTOMLEFT", o.combatmask3, "BOTTOMLEFT", 0, 22.8)
			o.relation:SetPoint("TOPCENTER", o.main, "TOPCENTER", -2, 26)
			o.title:SetPoint("TOPCENTER", o.main, "TOPCENTER", -2, 2)
		end
		
		if width then
			o.copy:SetPoint("LEFTCENTER", o.totaltext1, "LEFTCENTER", 0, 0.64)
			o.main:SetBackgroundColor(0, 0, 0, alpha)
			o.combattotal1:SetWidth(width - 108)
			o.combatmask1:SetWidth(width - 108)
			o.mainbg:SetWidth(width - 8)
			o.main:SetVisible(visible)
			o.main:SetWidth(width)
		end
		
		if not start and reset then
			Command.Message.Accept("send", "sync")
			SuperMeter.Interface.Slots()
		end
		
		if not start and export then
			for k,v in pairs(export) do
				SuperMeter.Clean(export[k])
			end
		end
		
		if show and not log then
			SuperMeter_logShowing = false
			o.plog:SetVisible(false)
			o.LogText("")
		end
		
		if warfront then
			o.PvP()
		end
		
		o.Update()
	end

	function o.Slots()
		local sessions = SuperMeter.Sessions
		local slots = SuperMeter_maxSlots
		local merge = SuperMeter_merge
		
		if #sessions >= 100 then
			o.next:SetPoint("BOTTOMRIGHT", o.menusbg, "BOTTOMRIGHT", -4, 0.88)
			o.last:SetPoint("BOTTOMLEFT", o.menusbg, "BOTTOMLEFT", 4, 0.88)
		else
			o.next:SetPoint("BOTTOMRIGHT", o.menusbg, "BOTTOMRIGHT", -12, 0.88)
			o.last:SetPoint("BOTTOMLEFT", o.menusbg, "BOTTOMLEFT", 12, 0.88)
		end
		
		if #sessions <= 0 or merge then
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0.40, 20)
		elseif #sessions == 1 then
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 1.28, 20)
		elseif #sessions <= 9 then
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0.80, 20)
		elseif #sessions == 10 then
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", -0.6, 20)
		elseif #sessions == 11 then
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0.48, 20)
		elseif #sessions <= 19 then
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", -0.2, 20)
		elseif #sessions >= 100 then
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", -0.28, 20)
		else
			o.index:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0.2, 20)
		end
		
		if sessions and slots then
			o.slots:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0, 2)
			o.slots:SetText(string.format("%02d Slots", slots))
			o.mainslider:SetRange(0, 0)
		end
		
		if slots and slots == 5.02 or slots < 2 then
			o.slots:SetText("Self Slot")
			slots = 5.02
		end
		
		if slots and slots == 28 then
			o.slots:SetText("All Slots")
			slots = 28
		end
		
		o.Display()
	end

	function o.ResetText()
		o.totaltext1:SetVisible(true)
		o.combattext1:SetText("")
		o.combattext2:SetText("")
		o.combattext3:SetText("")
		o.copy:SetKeyFocus(false)
		o.totaltext1:SetText("")
		o.totaltext2:SetText("")
		o.totaltext3:SetText("")
		o.copy:SetVisible(false)
		o.copy:SetText("")
	end

	function o.Text(list, nameText, mode1Text, mode2Text)
		if o.state.mouseDown1 then return end
		
		local interval = SuperMeter.Metrics("full")
		local trim = SuperMeter.Metrics("offset")
		
		o.combattext2:SetText(mode1Text, true)
		o.combattext3:SetText(mode2Text, true)
		o.combattext1:SetText(nameText, true)
		
		local height = interval * #list - trim
		local alpha = SuperMeter_alpha - 0.42
		local session = SuperMeter.Session()
		local display = SuperMeter_display
		local minimal = SuperMeter_minimal
		local slots = SuperMeter_maxSlots
		local player = SuperMeter.Player
		local sticky = SuperMeter_sticky
		local grow = SuperMeter_growUp
		local self = SuperMeter_self
		local side = SuperMeter_side
		local integer = tonumber
		local math = math.floor
		
		local colours = {}
		
		local index = 0
		local total = 0
		local width = 0
		
		if #list > slots then
			o.mainslider:SetRange(0, height + trim - interval * slots)
			height = interval * math(slots) - trim
			SuperMeter_scroll = height
		else
			SuperMeter_scroll = false
		end
		
		if #list > slots and slots == 5.02 and side == "Enemies" then
			height = interval * math(slots) - trim
			SuperMeter_scroll = false
		end
		
		if #list > 0 and slots == 5.02 and side == "Allies" then
			SuperMeter_scroll = false
			height = interval - trim
		end
		
		for i = 1, #list do
			if list[i].name == player.name and self then
				table.insert(colours, {r = 0.068, g = 0.488, b = 1.000})
			elseif list[i].calling == "warrior" then
				table.insert(colours, {r = 1.000, g = 0.000, b = 0.000})
			elseif list[i].calling == "cleric" then
				table.insert(colours, {r = 0.280, g = 0.880, b = 0.000})
			elseif list[i].calling == "rogue" then
				table.insert(colours, {r = 0.860, g = 0.800, b = 0.000})
			elseif list[i].calling == "mage" then
				table.insert(colours, {r = 0.620, g = 0.400, b = 1.000})
			else
				table.insert(colours, {r = 0.068, g = 0.488, b = 1.000})
			end
			if slots == 5.02 and list[i].name == player.name then
				index = integer(i)
			end
		end
		
		if slots == 5.02 and display == "Bars" then
			if index and index > 0 and side == "Allies" then
				colours = {[1] = colours[index]}
			end
		end
		
		if minimal then
			if list and list[1] then
				o.main:SetHeight(height + 30 - 0.4)
			else
				o.main:SetHeight(26.8)
			end
			o.mainbg:SetVisible(false)
		else
			if list and list[1] then
				o.main:SetHeight(height + 76 - 0.4)
			else
				o.main:SetHeight(72.8)
			end
			o.mainbg:SetVisible(true)
		end
		
		if #list > 0 then
			o.combatmask1:SetHeight(height)
			o.combatmask2:SetHeight(height)
			o.combatmask3:SetHeight(height)
		else
			o.combatmask1:SetHeight(0)
			o.combatmask2:SetHeight(0)
			o.combatmask3:SetHeight(0)
		end
		
		if display == "Bars" then
			width = o.combatmask1:GetWidth()
		else
			width = SuperMeter_width
		end
		
		if list[1] and list[1].mode then
			total = list[1].mode
		end
		
		if not o.plog:GetVisible() then
			o.plogmask:SetWidth(2000)
		end
		
		if grow and not sticky then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y - o.main:GetHeight() + 72.8)
		elseif not sticky then
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y)
		end
		
		if display == "Bars" and list[1] and colours[1] and list[1].mode / total > 0 then
			o.unitbar1:SetBackgroundColor(colours[1].r, colours[1].g, colours[1].b, alpha)
			o.unitbar1:SetWidth(list[1].mode / total * width)
			o.unitbar1:SetVisible(not not colours[1])
		else
			o.unitbar1:SetVisible(false)
		end
		
		if display == "Bars" and list[2] and colours[2] and list[2].mode / total > 0 then
			o.unitbar2:SetBackgroundColor(colours[2].r, colours[2].g, colours[2].b, alpha)
			o.unitbar2:SetWidth(list[2].mode / total * width)
			o.unitbar2:SetVisible(not not colours[2])
		else
			o.unitbar2:SetVisible(false)
		end
		
		if display == "Bars" and list[3] and colours[3] and list[3].mode / total > 0 then
			o.unitbar3:SetBackgroundColor(colours[3].r, colours[3].g, colours[3].b, alpha)
			o.unitbar3:SetWidth(list[3].mode / total * width)
			o.unitbar3:SetVisible(not not colours[3])
		else
			o.unitbar3:SetVisible(false)
		end
		
		if display == "Bars" and list[4] and colours[4] and list[4].mode / total > 0 then
			o.unitbar4:SetBackgroundColor(colours[4].r, colours[4].g, colours[4].b, alpha)
			o.unitbar4:SetWidth(list[4].mode / total * width)
			o.unitbar4:SetVisible(not not colours[4])
		else
			o.unitbar4:SetVisible(false)
		end
		
		if display == "Bars" and list[5] and colours[5] and list[5].mode / total > 0 then
			o.unitbar5:SetBackgroundColor(colours[5].r, colours[5].g, colours[5].b, alpha)
			o.unitbar5:SetWidth(list[5].mode / total * width)
			o.unitbar5:SetVisible(not not colours[5])
		else
			o.unitbar5:SetVisible(false)
		end
		
		if display == "Bars" and list[6] and colours[6] and list[6].mode / total > 0 then
			o.unitbar6:SetBackgroundColor(colours[6].r, colours[6].g, colours[6].b, alpha)
			o.unitbar6:SetWidth(list[6].mode / total * width)
			o.unitbar6:SetVisible(not not colours[6])
		else
			o.unitbar6:SetVisible(false)
		end
		
		if display == "Bars" and list[7] and colours[7] and list[7].mode / total > 0 then
			o.unitbar7:SetBackgroundColor(colours[7].r, colours[7].g, colours[7].b, alpha)
			o.unitbar7:SetWidth(list[7].mode / total * width)
			o.unitbar7:SetVisible(not not colours[7])
		else
			o.unitbar7:SetVisible(false)
		end
		
		if display == "Bars" and list[8] and colours[8] and list[8].mode / total > 0 then
			o.unitbar8:SetBackgroundColor(colours[8].r, colours[8].g, colours[8].b, alpha)
			o.unitbar8:SetWidth(list[8].mode / total * width)
			o.unitbar8:SetVisible(not not colours[8])
		else
			o.unitbar8:SetVisible(false)
		end
		
		if display == "Bars" and list[9] and colours[9] and list[9].mode / total > 0 then
			o.unitbar9:SetBackgroundColor(colours[9].r, colours[9].g, colours[9].b, alpha)
			o.unitbar9:SetWidth(list[9].mode / total * width)
			o.unitbar9:SetVisible(not not colours[9])
		else
			o.unitbar9:SetVisible(false)
		end
		
		if display == "Bars" and list[10] and colours[10] and list[10].mode / total > 0 then
			o.unitbar10:SetBackgroundColor(colours[10].r, colours[10].g, colours[10].b, alpha)
			o.unitbar10:SetWidth(list[10].mode / total * width)
			o.unitbar10:SetVisible(not not colours[10])
		else
			o.unitbar10:SetVisible(false)
		end
		
		if display == "Bars" and list[11] and colours[11] and list[11].mode / total > 0 then
			o.unitbar11:SetBackgroundColor(colours[11].r, colours[11].g, colours[11].b, alpha)
			o.unitbar11:SetWidth(list[11].mode / total * width)
			o.unitbar11:SetVisible(not not colours[11])
		else
			o.unitbar11:SetVisible(false)
		end
		
		if display == "Bars" and list[12] and colours[12] and list[12].mode / total > 0 then
			o.unitbar12:SetBackgroundColor(colours[12].r, colours[12].g, colours[12].b, alpha)
			o.unitbar12:SetWidth(list[12].mode / total * width)
			o.unitbar12:SetVisible(not not colours[12])
		else
			o.unitbar12:SetVisible(false)
		end
		
		if display == "Bars" and list[13] and colours[13] and list[13].mode / total > 0 then
			o.unitbar13:SetBackgroundColor(colours[13].r, colours[13].g, colours[13].b, alpha)
			o.unitbar13:SetWidth(list[13].mode / total * width)
			o.unitbar13:SetVisible(not not colours[13])
		else
			o.unitbar13:SetVisible(false)
		end
		
		if display == "Bars" and list[14] and colours[14] and list[14].mode / total > 0 then
			o.unitbar14:SetBackgroundColor(colours[14].r, colours[14].g, colours[14].b, alpha)
			o.unitbar14:SetWidth(list[14].mode / total * width)
			o.unitbar14:SetVisible(not not colours[14])
		else
			o.unitbar14:SetVisible(false)
		end
		
		if display == "Bars" and list[15] and colours[15] and list[15].mode / total > 0 then
			o.unitbar15:SetBackgroundColor(colours[15].r, colours[15].g, colours[15].b, alpha)
			o.unitbar15:SetWidth(list[15].mode / total * width)
			o.unitbar15:SetVisible(not not colours[15])
		else
			o.unitbar15:SetVisible(false)
		end
		
		if display == "Bars" and list[16] and colours[16] and list[16].mode / total > 0 then
			o.unitbar16:SetBackgroundColor(colours[16].r, colours[16].g, colours[16].b, alpha)
			o.unitbar16:SetWidth(list[16].mode / total * width)
			o.unitbar16:SetVisible(not not colours[16])
		else
			o.unitbar16:SetVisible(false)
		end
		
		if display == "Bars" and list[17] and colours[17] and list[17].mode / total > 0 then
			o.unitbar17:SetBackgroundColor(colours[17].r, colours[17].g, colours[17].b, alpha)
			o.unitbar17:SetWidth(list[17].mode / total * width)
			o.unitbar17:SetVisible(not not colours[17])
		else
			o.unitbar17:SetVisible(false)
		end
		
		if display == "Bars" and list[18] and colours[18] and list[18].mode / total > 0 then
			o.unitbar18:SetBackgroundColor(colours[18].r, colours[18].g, colours[18].b, alpha)
			o.unitbar18:SetWidth(list[18].mode / total * width)
			o.unitbar18:SetVisible(not not colours[18])
		else
			o.unitbar18:SetVisible(false)
		end
		
		if display == "Bars" and list[19] and colours[19] and list[19].mode / total > 0 then
			o.unitbar19:SetBackgroundColor(colours[19].r, colours[19].g, colours[19].b, alpha)
			o.unitbar19:SetWidth(list[19].mode / total * width)
			o.unitbar19:SetVisible(not not colours[19])
		else
			o.unitbar19:SetVisible(false)
		end
		
		if display == "Bars" and list[20] and colours[20] and list[20].mode / total > 0 then
			o.unitbar20:SetBackgroundColor(colours[20].r, colours[20].g, colours[20].b, alpha)
			o.unitbar20:SetWidth(list[20].mode / total * width)
			o.unitbar20:SetVisible(not not colours[20])
		else
			o.unitbar20:SetVisible(false)
		end
		
		if display == "Bars" and list[21] and colours[21] and list[21].mode / total > 0 then
			o.unitbar21:SetBackgroundColor(colours[21].r, colours[21].g, colours[21].b, alpha)
			o.unitbar21:SetWidth(list[21].mode / total * width)
			o.unitbar21:SetVisible(not not colours[21])
		else
			o.unitbar21:SetVisible(false)
		end
		
		if display == "Bars" and list[22] and colours[22] and list[22].mode / total > 0 then
			o.unitbar22:SetBackgroundColor(colours[22].r, colours[22].g, colours[22].b, alpha)
			o.unitbar22:SetWidth(list[22].mode / total * width)
			o.unitbar22:SetVisible(not not colours[22])
		else
			o.unitbar22:SetVisible(false)
		end
		
		if display == "Bars" and list[23] and colours[23] and list[23].mode / total > 0 then
			o.unitbar23:SetBackgroundColor(colours[23].r, colours[23].g, colours[23].b, alpha)
			o.unitbar23:SetWidth(list[23].mode / total * width)
			o.unitbar23:SetVisible(not not colours[23])
		else
			o.unitbar23:SetVisible(false)
		end
		
		if display == "Bars" and list[24] and colours[24] and list[24].mode / total > 0 then
			o.unitbar24:SetBackgroundColor(colours[24].r, colours[24].g, colours[24].b, alpha)
			o.unitbar24:SetWidth(list[24].mode / total * width)
			o.unitbar24:SetVisible(not not colours[24])
		else
			o.unitbar24:SetVisible(false)
		end
		
		if display == "Bars" and list[25] and colours[25] and list[25].mode / total > 0 then
			o.unitbar25:SetBackgroundColor(colours[25].r, colours[25].g, colours[25].b, alpha)
			o.unitbar25:SetWidth(list[25].mode / total * width)
			o.unitbar25:SetVisible(not not colours[25])
		else
			o.unitbar25:SetVisible(false)
		end
		
		if display == "Bars" and list[26] and colours[26] and list[26].mode / total > 0 then
			o.unitbar26:SetBackgroundColor(colours[26].r, colours[26].g, colours[26].b, alpha)
			o.unitbar26:SetWidth(list[26].mode / total * width)
			o.unitbar26:SetVisible(not not colours[26])
		else
			o.unitbar26:SetVisible(false)
		end
		
		if display == "Bars" and list[27] and colours[27] and list[27].mode / total > 0 then
			o.unitbar27:SetBackgroundColor(colours[27].r, colours[27].g, colours[27].b, alpha)
			o.unitbar27:SetWidth(list[27].mode / total * width)
			o.unitbar27:SetVisible(not not colours[27])
		else
			o.unitbar27:SetVisible(false)
		end
		
		if display == "Bars" and list[28] and colours[28] and list[28].mode / total > 0 then
			o.unitbar28:SetBackgroundColor(colours[28].r, colours[28].g, colours[28].b, alpha)
			o.unitbar28:SetWidth(list[28].mode / total * width)
			o.unitbar28:SetVisible(not not colours[28])
		else
			o.unitbar28:SetVisible(false)
		end
	end

	function o.Total(list, total1, total2)
		if o.state.mouseDown1 then return end
		
		local text1 = SuperMeter.Number(total1)
		local text2 = SuperMeter.Number(total2)
		local modeDesc = SuperMeter_modeDesc
		local minimal = SuperMeter_minimal
		local show = SuperMeter_showPlayer
		
		if list and list[1] then
			if not modeDesc and not show and not minimal then
				o.totaltext1:SetText("Total:")
				SuperMeter_value = true
			end
			o.totaltext2:SetText(text1)
			o.totaltext3:SetText(text2)
		else
			if not modeDesc then
				SuperMeter_value = false
				o.totaltext1:SetText("")
				o.totaltext2:SetText("")
				o.totaltext3:SetText("")
			end
		end
	end

	function o.LogText(text)
		o.plogtext:SetText(text, true)
		
		local tHeight = o.plogtext:GetHeight()
		local mHeight = o.plogmask:GetHeight()
		local width = o.plogtext:GetWidth()
		
		if text and width then
			o.plog:SetPoint("TOPCENTER", UIParent, "TOPCENTER", SuperMeter_logX, SuperMeter_logY)
		end
		
		if tHeight < mHeight then
			o.plogtext:SetPoint("TOPLEFT", o.plogmask, "TOPLEFT", 40, -2.8)
			o.plogslider:SetVisible(false)
			o.plogslider:SetRange(0, 0)
		else
			o.plogslider:SetRange(0, tHeight - mHeight - 6)
			o.plogslider:SetVisible(true)
			o.plogslider:Nudge(tHeight)
		end
		
		if width > 640 then
			o.plogtitlebg:SetWidth(width + 40)
			o.plogoutbg:SetWidth(width + 40)
			o.plogmask:SetWidth(width + 40)
			o.plog:SetWidth(width + 48)
		else
			o.plogtitlebg:SetWidth(670.8)
			o.plogoutbg:SetWidth(670.8)
			o.plogmask:SetWidth(670.8)
			o.plog:SetWidth(680.8)
		end
	end

	function o.LogTitle(text)
		o.plogtitle2:SetText(text)
	end

	function o.LogEntry(table)
		local height = o.plogtext:GetHeight()
		local top = o.plogtext:GetTop()
		local mouse = Inspect.Mouse()
		
		local interval = mouse.y - top
		local outputText = false
		local entry = false
		
		if not SuperMeter_logShowing then
			return entry
		end
		
		if table and table[1] then
			local max = height / #table
			o.copy:SetKeyFocus(false)
			for i = 1, interval / max do
				entry = table[i + 1]
			end
			if not entry then
				entry = table[1]
			end
		end
		
		if entry and string.match(entry, "#") then
			outputText = string.sub(entry, 23, -8)
		else
			outputText = entry
		end
		
		if outputText then
			o.totaltext1:SetVisible(o.copy:GetVisible())
			o.copy:SetVisible(not o.copy:GetVisible())
			o.copy:SetText(outputText)
			o.copy:SetKeyFocus(true)
		end
	end

	function o.Manager(set1, set2)
		if SuperMeter_combat then o.smgrm:SetVisible(false) return end
		if not SuperMeter_enabled then return end
		
		local sessions = SuperMeter.Sessions
		local export = SuperMeter.Export
		local mode1 = SuperMeter_mode1
		local format = string.format
		local mode = SuperMeter_mode
		local side = SuperMeter_side
		local time = SuperMeter.Time
		
		local setText1 = ""
		local setText2 = ""
		local text1 = ""
		local text2 = ""
		
		if side == "Allies" then
			SuperMeter_side = "Enemies"
		end
		
		if side and mode then
			SuperMeter_mode1 = "DPS"
			SuperMeter_mode = "DPS"
			SuperMeter.Data()
		end
		
		if export and sessions then
			SuperMeter.Upgrade()
		end
		
		for k,v in pairs(sessions) do
			if not v.name and v.enemies[1] then v.name = v.enemies[1].name end
			if not v.name and v.merge then v.name = "All Sessions Summary" end
			if not v.name and v.split then v.name = "Split Session" end
			if not v.name then v.name = "Empty Session" end
			
			if v.name then
				text1 = format("%0s[ %0s ][ %0s ] %0s\n", text1, format(k), time(v.combatTime), v.name)
				
				if set1 and v == SuperMeter_sessions then
					setText1 = format("[ %0s ][ %0s ] %0s", format(k), time(v.combatTime),v.name)
				end
			end
		end
		
		for k,v in pairs(export) do
			if not v.name and v.enemies[1] then v.name = v.enemies[1].name end
			if not v.name and v.merge then v.name = "All Sessions Summary" end
			if not v.name and v.split then v.name = "Split Session" end
			if not v.name then v.name = "Empty Session" end
			
			if v.name then
				text2 = format("%0s[ %0s ][ %0s ] %0s\n", text2, format(k), time(v.combatTime), v.name)
				
				if set2 and v == SuperMeter_exported then
					setText2 = format("[ %0s ][ %0s ] %0s", format(k), time(v.combatTime),v.name)
				end
			end
		end
		
		if o.smgrcm:GetHeight() < o.smgrc:GetHeight() then
			o.smgrcs:SetRange(0, o.smgrc:GetHeight() - o.smgrcm:GetHeight())
			o.smgrcs:SetVisible(true)
		else
			o.smgrcs:SetVisible(false)
		end
		
		if o.smgrsm:GetHeight() < o.smgrs:GetHeight() then
			o.smgrss:SetRange(0, o.smgrs:GetHeight() - o.smgrsm:GetHeight())
			o.smgrss:SetVisible(true)
		else
			o.smgrss:SetVisible(false)
		end
		
		if not set1 and not set2 then
			o.smgrt:SetText("Super Meter Session Manager")
			o.smgrct:SetText("Current Sessions")
			o.smgrst:SetText("Saved Sessions")
			o.smgrd:SetText("Delete")
			o.smgre:SetText("Export")
			o.smgrr:SetText("Rename")
			o.smgrv:SetText("View")
			o.smgrc:SetText(text1)
			o.smgrs:SetText(text2)
		end
		
		if set1 then
			o.smgrct:SetText(setText1)
		end
		
		if set2 then
			o.smgrst:SetText(setText2)
		end
		
		if side == "Allies" then
			SuperMeter_side = "Allies"
		end
		
		if side and mode then
			SuperMeter_mode1 = mode1
			SuperMeter_mode = mode
			SuperMeter.Data()
		end
	end

	function o.Sessions(session, export)
		local sessions = SuperMeter_sessions
		local exported = SuperMeter_exported
		
		local top1 = o.smgrc:GetTop()
		local top2 = o.smgrs:GetTop()
		local mouse = Inspect.Mouse()
		
		local i1 = mouse.y - 2 - top1
		local i2 = mouse.y - 2 - top2
		
		local data1 = false
		local data2 = false
		
		local max1 = 22
		local max2 = 22
		
		if session then
			if #SuperMeter.Sessions > 0 then
				max1 = o.smgrc:GetHeight() / #SuperMeter.Sessions
			end
			for i = 1, i1 / max1 do
				data1 = SuperMeter.Sessions[i + 1]
			end
			if not data1 then
				data1 = SuperMeter.Sessions[1]
			end
		end
		
		if export then
			if #SuperMeter.Export > 0 then
				max2 = o.smgrs:GetHeight() / #SuperMeter.Export
			end
			for i = 1, i2 / max2 do
				data2 = SuperMeter.Export[i + 1]
			end
			if not data2 then
				data2 = SuperMeter.Export[1]
			end
		end
		
		if sessions == data1 then
			o.smgrct:SetText("Current Sessions")
			SuperMeter_sessions = false
			sessions = false
			session = false
		end
		
		if exported == data2 then
			o.smgrst:SetText("Saved Sessions")
			SuperMeter_exported = false
			exported = false
			export = false
		end
		
		if not sessions and not exported then
			o.smgre:SetEnabled(false)
			o.smgrv:SetEnabled(false)
			o.smgrr:SetEnabled(false)
			o.smgrd:SetEnabled(false)
		end
		
		if session then
			SuperMeter_sessions = data1
			SuperMeter.Clean(data1)
			o.Manager(true, false)
		end
		
		if export then
			SuperMeter_exported = data2
			SuperMeter.Clean(data2)
			o.Manager(false, true)
		end
		
		if export or session then
			o.smgre:SetEnabled(true)
			o.smgrr:SetEnabled(true)
			o.smgrd:SetEnabled(true)
		end
	end

	function o.Change()
		local sessions = SuperMeter.Sessions
		local log = SuperMeter_logShowing
		local offset = SuperMeter.Offset
		local sticky = SuperMeter_sticky
		local merge = SuperMeter_merge
		
		if not merge then
			if #SuperMeter.Sessions <= 0 then
				o.index:SetText("00 - 00")
			else
				o.index:SetText(string.format("%02d - %02d", #sessions - offset, #sessions))
			end
		end
		
		if sessions then
			SuperMeter.Clean(sessions[#sessions - offset - 1])
			SuperMeter.Clean(SuperMeter_view)
			o.mainslider:SetRange(0, 0)
		end
		
		if sticky then
			SuperMeter_position = false
			SuperMeter_sticky = false
			o.TipHide()
		end
		
		if log then
			SuperMeter.Entry()
		end
		
		o.Update(2)
		o.Slots()
		o.Time()
	end

	function o.Mode(mode)
		local data = {count1 = 0, count2 = 0, info1 = 0, info2 = 0}
		local info = {casters = {}, targets = {}}
		
		local unit = o.Unit()
		
		if not unit then unit = info end
		
		if mode == "DFT" then
			data.casters = unit.casters.damageDeflected
			data.key = "damageDeflected"
			data.string2 = "Deflected"
			data.string1 = "Attacks"
		end
		
		if mode == "ASB" then
			data.casters = unit.casters.damageAbsorbed
			data.key = "damageAbsorbed"
			data.string2 = "Absorbed"
			data.string1 = "Attacks"
		end
		
		if mode == "BLK" then
			data.casters = unit.casters.damageBlocked
			data.key = "damageBlocked"
			data.string1 = "Attacks"
			data.string2 = "Blocked"
		end
		
		if mode == "OHG" or mode == "OPS" then
			data.targets = unit.targets.overHealing
			data.string2 = "Criticals"
			data.key = "overHealing"
			data.string1 = "Heals"
		end
		
		if mode == "OKL" then
			data.targets = unit.targets.overKill
			data.string2 = "Criticals"
			data.string1 = "Attacks"
			data.key = "overKill"
		end
		
		if mode == "HTN" then
			data.casters = unit.casters.healing
			data.string2 = "Criticals"
			data.key = "healingTaken"
			data.string1 = "Heals"
		end
		
		if mode == "HLG" or mode == "HPS" then
			data.targets = unit.targets.healing
			data.string2 = "Criticals"
			data.string1 = "Heals"
			data.key = "healing"
		end
		
		if mode == "AVD" then
			data.casters = unit.casters.hitless
			data.key = "damageAvoided"
			data.string1 = "Attacks"
			data.string2 = "Avoided"
		end
		
		if mode == "MSD" then
			data.targets = unit.targets.hitless
			data.key = "damageMissed"
			data.string1 = "Attacks"
			data.string2 = "Missed"
		end
		
		if mode == "DMG" or mode == "DPS" then
			data.targets = unit.targets.damage
			data.string2 = "Criticals"
			data.string1 = "Attacks"
			data.key = "damage"
		end
		
		if mode == "DTN" then
			data.casters = unit.casters.damage
			data.string2 = "Criticals"
			data.key = "damageTaken"
			data.string1 = "Attacks"
		end
		
		if data.casters then
			for k1,v1 in pairs(data.casters) do
				data.count1 = data.count1 + v1
			end
			
			for k1,v1 in pairs(unit.casters) do
				if data.key and data.info1 and (k1 == "damage" or k1 == "hitless") then
					for k2,v2 in pairs(unit.casters[k1]) do
						data.info1 = data.info1 + v2
					end
				end
			end
		end
		
		if data.targets then
			for k1,v1 in pairs(data.targets) do
				data.count2 = data.count2 + v1
			end
			
			for k1,v1 in pairs(unit.targets) do
				if data.key and data.info2 and (k1 == "damage" or k1 == "hitless") then
					for k2,v2 in pairs(unit.targets[k1]) do
						data.info2 = data.info2 + v2
					end
				end
			end
		end
		
		return data
	end

	function o.Tooltip(advanced)
		local position = SuperMeter_position
		local session = SuperMeter.Session()
		local mode = SuperMeter_ModeRequest
		local combat = SuperMeter_combat
		local font = SuperMeter_fontSize
		local number = SuperMeter.Number
		local time = session.combatTime
		local format = string.format
		local side = SuperMeter_side
		local data = o.Mode(mode)
		local unit = o.Unit()
		
		local casters = false
		local targets = false
		
		local abilities = {}
		local list = {}
		
		local aTitle1 = ""
		local aTitle2 = ""
		local calling = ""
		local title1 = ""
		local title2 = ""
		local data1 = ""
		local info1 = ""
		local data2 = ""
		local info2 = ""
		
		local count1 = 0
		local count2 = 0
		local total = 0
		
		if not (SuperMeter_abilityMode == mode) then
			SuperMeter_abilityUnit = false
		end
		
		if unit == SuperMeter_abilityUnit then
			if not advanced then
				return
			end
		end
		
		if combat and unit and unit.name then
			SuperMeter.Data(session)
		end
		
		if side == "Enemies" then
			list = session.enemies
		else
			list = session.allies
		end
		
		if unit and unit.name then
			if unit.calling and unit.level then
				calling = format("(%0s) ", unit.calling:gsub("^%l", string.upper))
			end
			
			for k,v in pairs(unit.abilities) do
				if v[data.key] and v[data.key].value > 0 then
					table.insert(abilities, k)
					total = unit[data.key]
				end
			end
			
			if position or SuperMeter_sticky then
				SuperMeter_sticky = false
				position = true
			end
			
			if #abilities > 28 then
				for i = 28 + 1, #abilities do
					abilities[i] = nil
				end
			end
			
			if unit.level == "??" then
				calling = "(Boss) "
			end
		end
		
		if #abilities > 0 and total > 0 then
			table.sort(abilities, function(a, b) return unit.abilities[a][data.key].value > unit.abilities[b][data.key].value end)
		end
		
		if total > 0 and not session.merge then
			aTitle1 = format("%0s's %0sCritical Breakdown:\n\n", unit.name, calling)
			aTitle2 = format("%0s's %0sAbility Breakdown:\n\n", unit.name, calling)
			title1 = format("%0s's %0sAbility Data:\n\n", unit.name, calling)
			title2 = format("%0s's %0sCombat Data:\n\n", unit.name, calling)
		else
			o.TipHide() return session.merge
		end
		
		for k,v in pairs(abilities) do
			local ability = unit.abilities[v]
			
			local critCount = ability[data.key].critCount
			local critLess = ability[data.key].critLess
			local critMax = ability[data.key].critMax
			local critMin = ability[data.key].critMin
			local tooltip = ability[data.key].tooltip
			local count = ability[data.key].count
			local value = ability[data.key].value
			local max = ability[data.key].max
			local min = ability[data.key].min
			
			if mode == "ASB" or mode == "AVD" or mode == "BLK" or mode == "DFT" or mode == "MSD" then
				count2 = ((mode == "MSD") and data.count2 or not (mode == "MSD") and data.count1 or 0)
				count1 = ((mode == "MSD") and data.info2 or not (mode == "MSD") and data.info1 or 0)
			else
				count1 = count1 + count + critCount
				count2 = count2 + critCount
			end
			
			if ability and not tooltip then
				tooltip = ""
			end
			
			if advanced and value > 0 then
				local critAvg = (critMax + critMin) / 2
				local avg = (max + min) / 2
				
				if mode == "DPS" or mode == "HPS" or mode == "OPS" then
					critMin = format("%.0f", critMin / time)
					critMax = format("%.0f", critMax / time)
					min = format("%.0f", min / time)
					max = format("%.0f", max / time)
					critAvg = critAvg / time
					avg = avg / time
				end
				
				if font == 14 then
					info2 = format("%0s%0s", info2, format("MAX:  %-012s\tAVG:  %-012s\tMIN:  %-012s\tCOUNT:  %-014s\t%-04s\n", critMax, format("%.0f", critAvg), critMin, critCount, format("%0s%0s", v, tooltip)))
					data2 = format("%0s%0s", data2, format("MAX:  %-012s\tAVG:  %-012s\tMIN:  %-012s\tCOUNT:  %-014s\t%-04s\n", max, format("%.0f", avg), min, count, format("%0s%0s", v, tooltip)))
				else
					info2 = format("%0s%0s", info2, format("MAX:  %-014s\tAVG:  %-014s\tMIN:  %-014s\tCOUNT:  %-016s\t%-04s\n", critMax, format("%.0f", critAvg), critMin, critCount, format("%0s%0s", v, tooltip)))
					data2 = format("%0s%0s", data2, format("MAX:  %-014s\tAVG:  %-014s\tMIN:  %-014s\tCOUNT:  %-016s\t%-04s\n", max, format("%.0f", avg), min, count, format("%0s%0s", v, tooltip)))
				end
			end
			
			if not advanced and value > 0 then
				local abilityValue = number(value)
				local nonan = 0.0000002
				
				if mode == "DPS" or mode == "HPS" or mode == "OPS" then
					abilityValue = number(value / time)
				end
				
				if font == 14 then
					info1 = format("%0s%0s", info1, format("%-014s\t%-014s\t%-04s\n", format("[ %0s ]", abilityValue), format("[ %0s ]", format("%.2f%%", value / total * 100)), format("%0s%0s", v, tooltip)))
					data1 = format("[ %0s %0s ] [ %0s %0s ] [ %0s ]\n", count1, data.string1, count2, data.string2, format("%.2f%%", count2 / (count1 - (critLess or 0) + nonan) * 100))
				else
					info1 = format("%0s%0s", info1, format("%-014s\t%-014s\t%-04s\n", format("[ %0s ]", abilityValue), format("[ %0s ]", format("%.2f%%", value / total * 100)), format("%0s%0s", v, tooltip)))
					data1 = format("[ %0s %0s ] [ %0s %0s ] [ %0s ]\n", count1, data.string1, count2, data.string2, format("%.2f%%", count2 / (count1 - (critLess or 0) + nonan) * 100))
				end
			end
		end
		
		if data.casters or data.targets then
			data1 = format("%0s%0s", data1, SuperMeter.Count(data.casters, data.targets))
		end
		
		if advanced then
			o.datatipShow(format("%0s%0s", aTitle1, info2), true)
			o.infotipShow(format("%0s%0s", aTitle2, data2), true)
		else
			o.datatipShow(format("%0s%0s", title1, info1))
			o.infotipShow(format("%0s%0s", title2, data1))
		end
		
		if position then
			SuperMeter_sticky = true
		end
		
		SuperMeter_ModeRequest = false
		SuperMeter_abilityMode = mode
		SuperMeter_abilityUnit = unit
	end

	function o.Update(refresh, export)
		if not SuperMeter_enabled then return end
		
		local session = SuperMeter.Session()
		local display = SuperMeter_display
		local show = SuperMeter_showPlayer
		local slots = SuperMeter_maxSlots
		local number = SuperMeter.Number
		local player = SuperMeter.Player
		local mode1 = SuperMeter_mode1
		local mode2 = SuperMeter_mode2
		local format = string.format
		local self = SuperMeter_self
		local side = SuperMeter_side
		local rank = SuperMeter_rank
		
		local exportText1 = ""
		local exportText2 = ""
		local mode1Text = ""
		local mode2Text = ""
		local nameText = ""
		local colour = ""
		
		local total1 = 0
		local total2 = 0
		
		local list = {}
		local name = {}
		
		if session and refresh then
			SuperMeter.Data()
		end
		
		if side == "Enemies" then
			list = session.enemies
		else
			list = session.allies
		end
		
		for k,v in ipairs(list) do
			if slots and slots == 5.02 then
				if v.name == player.name or side == "Enemies" then
					slots = SuperMeter_maxSlots
				else
					v.calling = false
					v.name = false
				end
			end
			
			if v.name then
				name[k] = {text = v.name}
			end
			
			if rank and v.name then
				name[k].text = format("%0s: %0s", k , v.name)
			end
			
			if display == "Calling" then
				if v.name == player.name and self then
					colour = format("<font color=%0s#2A88FF%0s>", '"', '"')
				elseif v.calling == "warrior" then
					colour = format("<font color=%0s#F20000%0s>", '"', '"')
				elseif v.calling == "cleric" then
					colour = format("<font color=%0s#4ACD00%0s>", '"', '"')
				elseif v.calling == "rogue" then
					colour = format("<font color=%0s#EAE000%0s>", '"', '"')
				elseif v.calling == "mage" then
					colour = format("<font color=%0s#8254F2%0s>", '"', '"')
				else
					colour = format("<font color=%0s#2A88FF%0s>", '"', '"')
				end
				
				if v.name and name[k].text then
					name[k].text = format("%0s%0s</font>", colour, name[k].text)
				end
			end
			
			if v.mode1 and v.mode2 and v.name then
				mode1Text = format("%0s%0s\n", mode1Text, number(v.mode1))
				mode2Text = format("%0s%0s\n", mode2Text, number(v.mode2))
				nameText = format("%0s%0s\n", nameText, name[k].text)
			end
			
			if export and v.name then
				local time = SuperMeter.Time(session.combatTime)
				local width1 = exportText1:len()
				local width2 = exportText2:len()
				
				if export == "mode1" and v.mode1 and width1 <= 180 then
					exportText1 = format("%0s  %0s: %0s", exportText1, v.name, number(v.mode1))
					o.copy:SetText(format("%0s %0s %0s%0s", side, mode1, time, exportText1))
				end
				
				if export == "mode2" and v.mode2 and width2 <= 180 then
					exportText2 = format("%0s  %0s: %0s", exportText2, v.name, number(v.mode2))
					o.copy:SetText(format("%0s %0s %0s%0s", side, mode2, time, exportText2))
				end
				
				o.copy:SetKeyFocus(false)
				o.copy:SetKeyFocus(true)
			end
			
			if show then
				if rank and v.name == player.name then
					o.totaltext1:SetText(format("<font color=%0s#2A88FF%0s>%0s: %0s</font>", '"', '"', k, v.name), true)
					name.show = true
				end
				
				if v.name == player.name then
					total1 = v.mode1
					total2 = v.mode2
				end
			else
				total1 = total1 + v.mode1
				total2 = total2 + v.mode2
			end
		end
		
		if show and not name.show then
			o.totaltext1:SetText(format("<font color=%0s#2A88FF%0s>%0s</font>", '"', '"', player.name), true)
		end
		
		o.Text(list, nameText, mode1Text, mode2Text)
		o.Total(list, total1, total2)
	end

	function o.Unit()
		local session = SuperMeter.Session()
		local top = o.combattext1:GetTop()
		local slots = SuperMeter_maxSlots
		local player = SuperMeter.Player
		local max = SuperMeter_interval
		local mouse = Inspect.Mouse()
		local side = SuperMeter_side
		
		local interval = mouse.y - 2 - top
		local unit = false
		local list = {}
		
		if side == "Enemies" then
			list = session.enemies
		else
			list = session.allies
		end
		
		if list and list[1] then
			for i = 1, interval / max do
				unit = list[i + 1]
			end
			if not unit then
				unit = list[1]
			end
		end
		
		if slots == 5.02 then
			if side == "Allies" and session.units[player.id] then
				return session.units[player.id]
			end
		end
		
		for k,v in pairs(session.units) do
			if unit and unit.identity == v.identity then
				return session.units[k]
			end
		end
	end

	function o.TipColour(mouseIn)
		local side = SuperMeter_side
		
		if mouseIn then
			if side == "Allies" then
				o.tipbg:SetBackgroundColor(0, 0.48, 0, 1)
			else
				o.tipbg:SetBackgroundColor(0.48, 0, 0, 1)
			end
		else
			o.tipbg:SetBackgroundColor(0, 0.40, 0.88, 1)
		end
	end

	function o.datatipShow(text, advanced)
		if SuperMeter_sticky then return end
		
		if text then
			o.datatiptext:SetText(text)
			o.datatip:SetHeight(o.datatiptext:GetHeight() + 10)
			o.datatip:SetWidth(o.datatiptext:GetWidth() + 16)
			
			if (o.datatiptext:GetWidth() + 16) < (SuperMeter_width - 2) then
				o.datatip:SetWidth(SuperMeter_width - 2)
			end
			
			if advanced then
				o.datatip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -SuperMeter_tipX, -SuperMeter_tipY)
				o.tipbg:SetWidth((o.datatip:GetWidth() * 2) + 3)
				o.tipbg:SetHeight(o.datatip:GetHeight() + 2)
			else
				o.datatip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -SuperMeter_tipX, -SuperMeter_tipY)
				o.tipbg:SetWidth(o.datatip:GetWidth() + 2)
				
				if o.infotip:GetVisible() then
					o.tipbg:SetHeight(o.datatip:GetHeight() + o.infotip:GetHeight() + 2.8)
				else
					o.tipbg:SetHeight(o.datatip:GetHeight() + 2)
				end
			end
			
			o.datatiptext:SetVisible(true)
			o.datatip:SetVisible(true)
			o.tipbg:SetVisible(true)
		end
	end

	function o.infotipShow(text, advanced)
		if SuperMeter_sticky then return end
		
		if text then
			o.infotiptext:SetText(text)
			o.infotip:SetWidth(o.datatip:GetWidth())
			o.infotip:SetHeight(o.infotiptext:GetHeight() + 10)
			
			if o.infotiptext:GetWidth() > o.datatiptext:GetWidth() then
				o.datatip:SetWidth(o.infotiptext:GetWidth() + 22)
				o.infotip:SetWidth(o.datatip:GetWidth())
			end
			
			if advanced then
				o.infotip:SetPoint("TOPLEFT", o.datatip, "TOPLEFT", -(o.infotip:GetWidth() + 1), 0)
				o.tipbg:SetWidth((o.datatip:GetWidth() * 2) + 3)
				o.tipbg:SetHeight(o.datatip:GetHeight() + 2)
			else
				o.infotip:SetPoint("TOPLEFT", o.datatip, "TOPLEFT", 0, -(o.infotip:GetHeight() + 1))
				o.tipbg:SetWidth(o.datatip:GetWidth() + 2)
				
				if o.datatip:GetVisible() then
					o.tipbg:SetHeight(o.datatip:GetHeight() + o.infotip:GetHeight() + 2.8)
				else
					o.tipbg:SetHeight(o.datatip:GetHeight() + 2)
				end
			end
			
			o.infotiptext:SetVisible(true)
			o.infotip:SetVisible(true)
			o.tipbg:SetVisible(true)
		end
	end

	function o.TipHide()
		if SuperMeter_sticky then return end
		
		if SuperMeter_abilityUnit then
			SuperMeter_abilityUnit = false
		end
		
		o.datatiptext:SetVisible(false)
		o.infotiptext:SetVisible(false)
		o.datatip:SetVisible(false)
		o.infotip:SetVisible(false)
		o.tipbg:SetVisible(false)
		o.datatiptext:SetText("")
		o.infotiptext:SetText("")
		
		o.TipColour()
	end

	function o.Select(mode)
		local select1 = SuperMeter_mode1Select
		local select2 = SuperMeter_mode2Select
		local master = SuperMeter_mode
		local mode1 = SuperMeter_mode1
		local mode2 = SuperMeter_mode2
		
		if select1 and master == mode1 then
			SuperMeter_mode = mode
		end
		
		if select2 and master == mode2 then
			SuperMeter_mode = mode
		end
		
		if select1 then
			SuperMeter_mode1Select = false
			SuperMeter_mode1 = mode
			o.mode1:SetText(mode)
		end
		
		if select2 then
			SuperMeter_mode2Select = false
			SuperMeter_mode2 = mode
			o.mode2:SetText(mode)
		end
	end

	function o.Rename(show)
		if SuperMeter_combat then return end
		
		o.Manager(SuperMeter_sessions, SuperMeter_exported)
		
		if not show then
			o.smname:SetKeyFocus(false)
			o.smname:SetVisible(false)
			o.smnbd:SetVisible(false)
			o.smgrd:SetText("Delete")
			o.smgrr:SetText("Rename")
			o.smgre:SetVisible(true)
			o.smgrv:SetVisible(true)
		else
			o.smname:SetKeyFocus(true)
			o.smname:SetVisible(true)
			o.smgre:SetVisible(false)
			o.smgrv:SetVisible(false)
			o.smgrd:SetText("Cancel")
			o.smgrr:SetText("Apply")
			o.smnbd:SetVisible(true)
		end
	end

	function o.Reset()
		o.mainslider:SetRange(0, 0)
		SuperMeter_combat = false
		SuperMeter.Sessions = {}
		SuperMeter.Refresh = 0
		SuperMeter.Offset = 0
		SuperMeter.Timer = 0
		o.Relation(true)
		o.Display(true)
		o.ResetEvent()
		o.ResetText()
		o.Manager()
		o.Slots()
	end

	function o.ResetFrame()
		o.smgrm:SetVisible(false)
		o.menus:SetVisible(false)
		o.plog:SetVisible(false)
	end

	function o.ResetEvent()
		SuperMeter.Player.combat = false
		SuperMeter_table = false
		SuperMeter_unit = false
		SuperMeter.Combat()
		SuperMeter.Entry()
	end

	function o.LogList()
		if o.plog:GetVisible() then
			SuperMeter_logShowing = false
		else
			o.plogtitle:SetText("Super Meter Player Session Logs")
			SuperMeter_logShowing = true
			SuperMeter_table = false
			SuperMeter_unit = false
		end
		
		o.plog:SetVisible(SuperMeter_logShowing)
		o.LogText("")
	end

	function o.Combat(refresh)
		local session = SuperMeter.Session()
		local inspect = Inspect.Unit.Detail
		local battle = SuperMeter.Battle
		local format = string.format
		
		local relation = ""
		local player = ""
		local name = ""
		local text = ""
		
		if not refresh then
			o.plog:SetVisible(not o.plog:GetVisible())
			SuperMeter_logShowing = false
			o.LogText("")
		end
		
		if refresh and o.plogtitle2:GetText() == "Help File" then
			return
		end
		
		if o.plog:GetVisible() then
			for k,v in pairs(battle) do
				local unit = inspect(format(k))
				local data = session.units[k]
				
				if unit then
					if not unit.relation and data then unit.relation = data.relation end
					if not unit.player then player = "False" else player = "True" end
					if not unit.name then name = "Unknown" else name = unit.name end
					if unit.relation == "friendly" then relation = "Friendly" end
					if unit.relation == "hostile" then relation = "Hostile" end
					if not unit.relation then relation = "Hostile" end
				end
				
				if unit and unit.combat or unit and unit.availability == "partial" and v then
					text = format("%0s[ Name: %0s ] [ Relation: %0s ] [ Player: %0s ] [ ID: %0s ]\n", text, name, relation, player, k)
				end
			end
			
			o.plogtitle:SetText("Super Meter Combat Table")
			o.LogTitle("Units In Combat")
			o.LogText(text)
		end
	end

	function o.Help()
		local text = SuperMeter.Help()
		
		if text then
			o.plog:SetVisible(not o.plog:GetVisible())
			SuperMeter_logShowing = false
			o.LogText("")
		end
		
		if o.plog:GetVisible() then
			if not SuperMeter_logShowing then
				o.plogtitle:SetText("Super Meter")
				o.LogTitle("Help File")
				o.LogText(text)
			end
		end
	end

	function o.PvP()
		local text = o.plogtitle2:GetText()
		local log = o.log:GetVisible()
		
		if not (text == "Units In Combat") then
			o.plog:SetVisible(false)
		end
		
		if log and text then
			o.log:SetVisible(false)
			o.help:SetVisible(true)
			o.LogText("")
		end
	end

	return o
end