local addon, shared = ...

local default_settings = { ic = 64, locked = false, expand = { direction = "down", align = "left" } }

local PAT = { UI = {} }


-- Modify "PAT.Rescale()" and PATRON_AVL/VETERAN_AVL when adding/removing abilities
local PATRON_ABILITIES = {
	["A665FDAC7EDD37636"] = {ix=1, en_name="Patron's Fast Pass"},
	["A0530A5F074940F78"] = {ix=2, en_name="Patron's Artifact Tracking"},
	["A54F1DA73C9D1D272"] = {ix=3, en_name="Bonus Warfront Charges"},
	["A1E12EB8E986727F7"] = {ix=4, en_name="Patron's Radiance"},
	["A3C7F03BBA1BBE8AD"] = {ix=5, en_name="Experience Bonus Suppression"},
	["A3D21C84687199B44"] = {ix=6, en_name="Summon Banker"},
	["A2EA96AD566F13C62"] = {ix=7, en_name="Summon Guild Banker"},
	["A439CC66597456366"] = {ix=8, en_name="Summon Cleric Trainer"},
	["AFD83E703841348C0"] = {ix=9, en_name="Summon Mage Trainer"},
	["A4090FAAA693ABEEC"] = {ix=10, en_name="Summon Rogue Trainer"},
	["A72F1082A8F6DD4C5"] = {ix=11, en_name="Summon Warrior Trainer"},
	["A3F5DD24F7FEF4C53"] = {ix=12, en_name="Patron's Mailbox"},
}
local VETERAN_ABILITIES = {
	["A0AE89C20B7D46D0F"] = {ix=1, en_name="Summon Personal Mailbox"},
	["A3416A1A673AEA8DF"] = {ix=2, en_name="Summon Veteran Vendor"},
}


local PATRON_AVL = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
}

local VETERAN_AVL = {
	0, 0
}

local curTTability = nil
local pbRefresh = false
local pbScale = false

local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

function PAT.RefreshBar()
	if Inspect.System.Secure() then
		pbRefresh = true
	else
		pbRefresh = false
		local actvcntt = 0
		local actvcntb = 0
		
		PAT.active = false

		local prevFrame = nil
		local prevCFrame = nil
		
		local txtWidth = 0
		
		for x,k in pairs(PATRON_AVL) do
			if k ~= 0 then
				if prevFrame == nil then
					PAT.UI.popup.f.t[x].f:SetPoint("TOPLEFT", PAT.UI.popup.c, "TOPLEFT")
				else
					PAT.UI.popup.f.t[x].f:SetPoint("TOPLEFT", prevFrame, "BOTTOMLEFT")
				end
				if prevCFrame == nil then
					PAT.UI.f[x]:SetPoint("TOPLEFT", PAT.UI.c_top, "TOPLEFT", 2,2)
				else
					PAT.UI.f[x]:SetPoint("TOPLEFT", prevCFrame, "TOPRIGHT", 1,0)
				end
				prevCFrame = PAT.UI.f[x]
				prevFrame = PAT.UI.popup.f.t[x].f
				
				PAT.active = true
				actvcntt = actvcntt + 1
				
				PAT.UI.f[x]:SetTexture("Rift", PATRON_ABILITIES[k].i)
				PAT.UI.popup.f.t[x].i:SetTexture("Rift", PATRON_ABILITIES[k].i)
				PAT.UI.popup.f.t[x].f:SetVisible(true)
				PAT.UI.f[x]:SetVisible(true)
				
				-- abilities on cooldown
				local ccr = PATRON_ABILITIES[k].ccr or 0
				if ccr > 0 then
					PAT.UI.popup.f.t[x].f:SetBackgroundColor(1,0,0,0.5)
				else
					PAT.UI.popup.f.t[x].f:SetBackgroundColor(0,0,0,0.5)
				end
				
				local m = string.format("cast %s", PATRON_ABILITIES[k].loc_name)
				PAT.UI.popup.f.t[x].t:SetText(PATRON_ABILITIES[k].loc_name)
				PAT.UI.popup.f.t[x].t:ClearWidth()
				txtWidth = math.max(txtWidth, PAT.UI.popup.f.t[x].t:GetWidth())
				PAT.UI.f[x].macro = m
				PAT.UI.popup.f.t[x].f:EventMacroSet(Event.UI.Input.Mouse.Left.Click, m)
				PAT.UI.f[x]:EventMacroSet(Event.UI.Input.Mouse.Left.Click, m)
			else
				PAT.UI.f[x]:SetVisible(false)
				PAT.UI.popup.f.t[x].f:SetVisible(false)
			end
		end

		prevCFrame = nil
		
		for x,k in pairs(VETERAN_AVL) do
			if k ~= 0 then
				if prevFrame == nil then
					PAT.UI.popup.f.b[x].f:SetPoint("TOPLEFT", PAT.UI.popup.c, "TOPLEFT")
				else
					PAT.UI.popup.f.b[x].f:SetPoint("TOPLEFT", prevFrame, "BOTTOMLEFT")
				end
				if prevCFrame == nil then
					PAT.UI.p[x]:SetPoint("TOPLEFT", PAT.UI.c_bot, "TOPLEFT", 2,2)
				else
					PAT.UI.p[x]:SetPoint("TOPLEFT", prevCFrame, "TOPRIGHT", 1,0)
				end
				prevCFrame = PAT.UI.p[x]
				prevFrame = PAT.UI.popup.f.b[x].f
				
				PAT.active = true
				actvcntb = actvcntb + 1
				
				PAT.UI.p[x]:SetTexture("Rift", VETERAN_ABILITIES[k].i)
				PAT.UI.popup.f.b[x].i:SetTexture("Rift", VETERAN_ABILITIES[k].i)
				PAT.UI.popup.f.b[x].f:SetVisible(true)
				PAT.UI.p[x]:SetVisible(true)
				
				-- abilities on cooldown
				local ccr = VETERAN_ABILITIES[k].ccr or 0
				if ccr > 0 then
					PAT.UI.popup.f.t[x].f:SetBackgroundColor(1,0,0,0.5)
				else
					PAT.UI.popup.f.t[x].f:SetBackgroundColor(0,0,0,0.5)
				end
				
				local m = string.format("cast %s", VETERAN_ABILITIES[k].loc_name)
				PAT.UI.popup.f.b[x].t:SetText(VETERAN_ABILITIES[k].loc_name)
				PAT.UI.popup.f.b[x].t:ClearWidth()
				txtWidth = math.max(txtWidth, PAT.UI.popup.f.b[x].t:GetWidth())
				PAT.UI.p[x].macro = m
				PAT.UI.p[x]:EventMacroSet(Event.UI.Input.Mouse.Left.Click, m)
				PAT.UI.popup.f.b[x].f:EventMacroSet(Event.UI.Input.Mouse.Left.Click, m)
			else
				PAT.UI.p[x]:SetVisible(false)
				PAT.UI.popup.f.b[x].f:SetVisible(false)
			end
		end
		
		for k,v in pairs(PAT.UI.popup.f.t) do
			v.f:SetWidth(txtWidth+24)
			v.t:SetWidth(txtWidth)
		end

		for k,v in pairs(PAT.UI.popup.f.b) do
			v.f:SetWidth(txtWidth+24)
			v.t:SetWidth(txtWidth)
		end
		
		local toph, topw
		local both, botw
		
		if actvcntt > 0 then
			toph = Patronage_Settings.ic+3
			topw = (actvcntt * (Patronage_Settings.ic+1))+3
			PAT.UI.c_top:SetWidth(topw)
			PAT.UI.c_top:SetHeight(toph)
		else
			toph = 1
			topw = 0
		end
		
		if actvcntb > 0 then
			both = Patronage_Settings.ic+3
			botw = (actvcntb * (Patronage_Settings.ic+1))+3
			PAT.UI.c_bot:SetWidth(botw)
			PAT.UI.c_bot:SetHeight(both)
		else
			both = 1
			botw = 0
		end
		
		PAT.popupW = math.max(topw, botw)
		PAT.popupH = toph + both
		
		PAT.UI.c:SetWidth(PAT.popupW)
		PAT.UI.c:SetHeight(PAT.popupH)
		
		PAT.UI.popup.c:SetWidth(24+txtWidth)
		PAT.UI.popup.c:SetHeight(24 * (actvcntt + actvcntb))
	end
end

function PAT.Event_Ability_New_Remove(h,t)
	for k,v in pairs(t) do
		if PATRON_ABILITIES[k] then
			PATRON_AVL = {0,0,0,0,0,0,0,0,0,0,0,0}
			break
		end
	end
end

function PAT.Event_Ability_New_Add(h,t)
	local barrefresh = false
	for k,v in pairs(t) do
		if PATRON_ABILITIES[k] then
			local ad = Inspect.Ability.New.Detail(k)
			PATRON_ABILITIES[k].loc_name = ad.name			
			PATRON_ABILITIES[k].i = ad.icon
			PATRON_ABILITIES[k].ccr = ad.currentCooldownRemaining or 0
			local c = PATRON_ABILITIES[k].ix
			PATRON_AVL[c] = k
			barrefresh = true		
		elseif VETERAN_ABILITIES[k] then
			local ad = Inspect.Ability.New.Detail(k)
			VETERAN_ABILITIES[k].loc_name = ad.name
			VETERAN_ABILITIES[k].i = ad.icon
			VETERAN_ABILITIES[k].ccr = ad.currentCooldownRemaining or 0
			local c = VETERAN_ABILITIES[k].ix
			VETERAN_AVL[c] = k
			barrefresh = true
		end
	end
	if barrefresh then
		PAT.RefreshBar()
	end
end

function PAT.RefreshAbilities()
	local barrefresh = false
	local ccr = 0
	for k,v in pairs(PATRON_ABILITIES) do
		local ad = Inspect.Ability.New.Detail(k)
		if ad then
			ccr = ad.currentCooldownRemaining or 0
		end
		if (PATRON_ABILITIES[k].ccr ~= ccr) then
			PATRON_ABILITIES[k].ccr = ccr
			barrefresh = true
		end
	end
	for k,v in pairs(VETERAN_ABILITIES) do
		local ad = Inspect.Ability.New.Detail(k)
		if ad then
			ccr = ad.currentCooldownRemaining or 0
		end
		if (VETERAN_ABILITIES[k].ccr ~= ccr) then
			VETERAN_ABILITIES[k].ccr = ccr
			barrefresh = true
		end
	end
	
	if barrefresh then
		PAT.RefreshBar()
	end
end

function PAT.CheckMouse()
	local md = Inspect.Mouse()
	local l = PAT.UI.popup.c:GetLeft()
	local r = PAT.UI.popup.c:GetRight()
	local t = PAT.UI.popup.c:GetTop()
	local b = PAT.UI.popup.c:GetBottom()
	
	if md.x < l or md.x > r or md.y < t or md.y > b then
		if Inspect.System.Secure() == false then
			PAT.UI.popup.c:SetVisible(false)
		end
		Command.Tooltip(nil)
	end
end

function PAT.BuildUI()
	PAT.UI.ctx = UI.CreateContext(addon.identifier)
	PAT.UI.ctx:SetSecureMode("restricted")
	
	PAT.UI.mm = UI.CreateFrame("Texture", "PAT.UI.mm", PAT.UI.ctx)
	PAT.UI.mm:SetHeight(36)
	PAT.UI.mm:SetWidth(36)
	
	PAT.UI.mm:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
		if Patronage_Settings.locked or MINIMAPDOCKER then
			if Inspect.System.Secure() == false then
				if not PAT.UI.popup.c:GetVisible() then
					PAT.RefreshAbilities()
					PAT.UI.popup.c:SetVisible(true)
				else
					PAT.UI.popup.c:SetVisible(false)
				end
			end
		end
	end, "Event.UI.Input.Mouse.Left.Click")

	if MINIMAPDOCKER == nil then
		PAT.UI.mm:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
			if Patronage_Settings.locked == false then
				self.MouseDown = true
				local mouseData = Inspect.Mouse()
				self.sx = mouseData.x - PAT.UI.mm:GetLeft()
				self.sy = mouseData.y - PAT.UI.mm:GetTop()
			end
		end, "Event.UI.Input.Mouse.Left.Down")

		PAT.UI.mm:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			self.MouseDown = false
			if Patronage_Settings.locked == false then
				Patronage_Settings.mmx = PAT.UI.mm:GetLeft()
				Patronage_Settings.mmy = PAT.UI.mm:GetTop()
			end
		end, "Event.UI.Input.Mouse.Left.Up")

		PAT.UI.mm:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
			if Patronage_Settings.locked == false and self.MouseDown then
				local nx, ny
				local mouseData = Inspect.Mouse()
				nx = mouseData.x - self.sx
				ny = mouseData.y - self.sy
				PAT.UI.mm:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx,ny)
			end
		end, "Event.UI.Input.Mouse.Cursor.Move")
		
		PAT.UI.mm:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
			self.MouseDown = false
			Patronage_Settings.locked = not Patronage_Settings.locked
			if Patronage_Settings.locked then
				PAT.UI.mm:SetTexture(addon.identifier, "img/mm_locked.png")
			else
				PAT.UI.mm:SetTexture(addon.identifier, "img/mm_unlocked.png")
			end
		end, "Event.UI.Input.Mouse.Right.Click")
	end

	PAT.UI.c = UI.CreateFrame("Frame", "PAT.Container", PAT.UI.ctx)
	PAT.UI.c:SetSecureMode("restricted")
	PAT.UI.c:SetVisible(false)
	PAT.UI.c:SetBackgroundColor(0,0,0,0.25)
	PAT.UI.c_top = UI.CreateFrame("Frame", "PAT.Container1", PAT.UI.c)
	PAT.UI.c_bot = UI.CreateFrame("Frame", "PAT.Container2", PAT.UI.c)
	PAT.UI.c_top:SetPoint("TOPCENTER", PAT.UI.c, "TOPCENTER")
	PAT.UI.c_bot:SetPoint("BOTTOMCENTER", PAT.UI.c, "BOTTOMCENTER")
	PAT.UI.c_top:SetSecureMode("restricted")
	PAT.UI.c_bot:SetSecureMode("restricted")

	PAT.UI.c:EventAttach(Event.UI.Input.Mouse.Wheel.Forward, function(self, h)
		if Inspect.System.Secure() == false then
			if Patronage_Settings.ic < 128 then
				Patronage_Settings.ic = Patronage_Settings.ic+1
				PAT.Rescale()
			end
		end
	end, "Event.UI.Input.Mouse.Wheel.Forward")
	
	PAT.UI.c:EventAttach(Event.UI.Input.Mouse.Wheel.Back, function(self, h)
		if Inspect.System.Secure() == false then
			if Patronage_Settings.ic > 8 then
				Patronage_Settings.ic = Patronage_Settings.ic-1
				PAT.Rescale()
			end
		end	
	end, "Event.UI.Input.Mouse.Wheel.Back")
	
	PAT.UI.popup = { f={ t={}, b={} } }	
	
	PAT.UI.popup.c = UI.CreateFrame("Frame", "PAT.UI.popup.c", PAT.UI.ctx)

	PAT.UI.popup.c:SetVisible(false)
	PAT.UI.popup.c:SetSecureMode("restricted")
	PAT.UI.popup.c:SetLayer(1)
	
	PAT.UI.f = {}
	PAT.UI.p = {}	
	

	for k,v in pairs(PATRON_ABILITIES) do
		local x = v.ix
		if PAT.UI.f[x] == nil then
			-- create MM button frames
			local f = UI.CreateFrame("Frame", "popupft#"..x, PAT.UI.popup.c)
			f:SetVisible(false)
			f:SetSecureMode("restricted")
			f:SetLayer(2)
			f:SetBackgroundColor(0,0,0,0.5)
			f:SetHeight(24)
			f:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
				local ccr = PATRON_ABILITIES[k].ccr or 0
				if (ccr <= 0) then
					f:SetBackgroundColor(0,1,0,0.5)
				end 
				Command.Tooltip(k)
			end, "Event.UI.Input.Mouse.Cursor.In")
			f:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
				local ccr = PATRON_ABILITIES[k].ccr or 0
				if (ccr <= 0) then
					f:SetBackgroundColor(0,0,0,0.5)
				end
				PAT.CheckMouse()
			end, "Event.UI.Input.Mouse.Cursor.Out")
			local i = UI.CreateFrame("Texture", "popupit#"..x, f)
			i:SetLayer(3)
			i:SetPoint("TOPLEFT", f, "TOPLEFT")
			i:SetWidth(24)
			i:SetHeight(24)
			local t = UI.CreateFrame("Text", "popuptt#"..x, f)
			t:SetLayer(3)
			t:SetPoint("TOPLEFT", i, "TOPRIGHT")
			t:SetFontSize(16)
			t:SetFontColor(1,1,1)
			PAT.UI.popup.f.t[x] = {f=f, i=i, t=t, m=nil}
			
			local b = UI.CreateFrame("Texture", "PAT.Button#"..x, PAT.UI.c_top)
			b:SetSecureMode("restricted")
			b:SetWidth(64)
			b:SetHeight(64)
			b:SetAlpha(0.6)
			b:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
				curTTability = x
				PAT.UI.f[x]:SetAlpha(1)
			end, "Event.UI.Input.Mouse.Cursor.In")
			b:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
				PAT.UI.f[x]:SetAlpha(0.6)
				if x == curTTability then
					curTTability = nil
				end
			end, "Event.UI.Input.Mouse.Cursor.Out")
			PAT.UI.f[x] = b
		end
	end

	for k,v in pairs(VETERAN_ABILITIES) do
		local x = v.ix
		if PAT.UI.p[x] == nil then
			local f = UI.CreateFrame("Frame", "popupfb#"..x, PAT.UI.popup.c)
			f:SetVisible(false)
			f:SetSecureMode("restricted")
			f:SetLayer(2)
			f:SetBackgroundColor(0,0,0,0.5)
			f:SetHeight(24)
			f:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
				local ccr = VETERAN_ABILITIES[k].ccr or 0
				if (ccr <= 0) then
					f:SetBackgroundColor(0,1,0,0.5)
				end
				Command.Tooltip(k)				
			end, "Event.UI.Input.Mouse.Cursor.In")
			f:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
				local ccr = VETERAN_ABILITIES[k].ccr or 0
				if (ccr <= 0) then
					f:SetBackgroundColor(0,0,0,0.5)
				end
				PAT.CheckMouse()
			end, "Event.UI.Input.Mouse.Cursor.Out")		
			local i = UI.CreateFrame("Texture", "popupib#"..x, f)
			i:SetLayer(3)
			i:SetPoint("TOPLEFT", f, "TOPLEFT")
			i:SetWidth(24)
			i:SetHeight(24)
			local t = UI.CreateFrame("Text", "popuptb#"..x, f)
			t:SetLayer(3)
			t:SetPoint("TOPLEFT", i, "TOPRIGHT")
			t:SetFontSize(16)
			t:SetFontColor(1,1,1)
			PAT.UI.popup.f.b[x] = {f=f, i=i, t=t, m=nil}
			
			local b = UI.CreateFrame("Texture", "PAT.Button#"..x, PAT.UI.c_bot)
			b:SetSecureMode("restricted")
			b:SetWidth(64)
			b:SetHeight(64)
			b:SetAlpha(0.6)
			b:EventAttach(Event.UI.Input.Mouse.Cursor.In, function(self, h)
				curTTability = x+10
				PAT.UI.p[x]:SetAlpha(1)
			end, "Event.UI.Input.Mouse.Cursor.In")
			b:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function(self, h)
				PAT.UI.p[x]:SetAlpha(0.6)
				if x+10 == curTTability then
					curTTability = nil
				end
			end, "Event.UI.Input.Mouse.Cursor.Out")
			PAT.UI.p[x] = b
		end
	end
end

function PAT.Command_Slash_Register(h, args)
	local r = {}
	local numargs = 0
	for token in string.gmatch(args, "[^%s]+") do
		numargs=numargs+1
		r[numargs] = token
	end

	if numargs > 0 then
		if r[1] == "toggle" then	
			if PAT.active then
				if Inspect.System.Secure() == false then
					if PAT.UI.c:GetVisible() then
						PAT.UI.c:SetVisible(false)
						if curTTability then
							Command.Tooltip(nil)
						end
						curTTability = nil
					else
						local sx = UIParent:GetWidth()
						local sy = UIParent:GetHeight()
						local md = Inspect.Mouse()
						local popx = 0
						local popy = 0
						if md.x < (PAT.popupW/2) then
							popx = 0
						elseif md.x > (sx - (PAT.popupW/2)) then
							popx = sx - PAT.popupW
						else
							popx = md.x - (PAT.popupW/2)
						end
						
						if md.y < (PAT.popupH/2) then
							popy = 0
						elseif md.y > (sy-(PAT.popupH/2)) then
							popy = sy-PAT.popupH
						else
							popy = md.y - (PAT.popupH/2)
						end
						
						PAT.UI.c:SetPoint("TOPLEFT", UIParent, "TOPLEFT", popx, popy)
						PAT.UI.c:SetVisible(true)
					end
				end
			else
				print("No Patron/Veteran abilities available!")
			end
		elseif r[1] == "check" then
			local s = ""
			local f = false
			local pabuff_name = {}
			for k,v in pairs(PATRON_ABILITIES) do
				pabuff_name[v.en_name] = k
			end
			for k,v in pairs(Inspect.Ability.New.Detail(Inspect.Ability.New.List())) do
				if pabuff_name[v.name] then
					if PATRON_ABILITIES[k] == nil then
						print(string.format("%s : ID = %s. NOT FOUND.", v.name, k))
						s = s..string.format("[%s : ID = %s. NOT FOUND.]", v.name, k)
						f=true
					end
				end
			end
			if f then
				error(s)
			end
		elseif r[1] == "size" then
			local sz = tonumber(r[2])
			if sz ~= nil then
				sz = math.floor(sz)
				if sz >= 8 and sz <= 128 then
					Patronage_Settings.ic = sz
					PAT.Rescale()
				else
					print("Range for size: 8 .. 128")
				end
			else
				print(sz.." is not a valid size. 8 .. 128")
			end
		end
	end
end

function PAT.Event_System_Secure_Enter(h)
	if PAT.UI.c:GetVisible() then
		PAT.UI.c:SetVisible(false)
		PAT.UI.popup.c:SetVisible(false)
		if curTTability then
			Command.Tooltip(nil)
		end
		curTTability = nil
	end
end

function PAT.Event_System_Secure_Leave(h)
	if pbRefresh then
		PAT.RefreshBar()
	end
	if pbScale then
		PAT.Rescale()
	end
end

function PAT.Rescale()
	if Inspect.System.Secure() == false then
		-- Patron Abilities
		for x=1,12 do
			PAT.UI.f[x]:SetWidth(Patronage_Settings.ic)
			PAT.UI.f[x]:SetHeight(Patronage_Settings.ic)
		end
		-- Veteran Abilities
		for x=1,2 do
			PAT.UI.p[x]:SetWidth(Patronage_Settings.ic)
			PAT.UI.p[x]:SetHeight(Patronage_Settings.ic)
		end
		PAT.RefreshBar()
		pbScale = false
	else
		pbScale = true
	end
end

function PAT.Event_Addon_SavedVariables_Load_End(h,a)
	if a == addon.identifier then
		if Patronage_Settings == nil then
			Patronage_Settings = {}
		end
		MergeTable(Patronage_Settings, default_settings)
		PAT.Rescale()
		if MINIMAPDOCKER then
			PAT.UI.mm:SetTexture(addon.identifier, "img/mm_locked.png")
			MINIMAPDOCKER.Register(addon.identifier, PAT.UI.mm)
		else
			if Patronage_Settings.locked then
				PAT.UI.mm:SetTexture(addon.identifier, "img/mm_locked.png")
			else
				PAT.UI.mm:SetTexture(addon.identifier, "img/mm_unlocked.png")
			end
			if (Patronage_Settings.mmx == nil) then
				Patronage_Settings.mmx = UIParent:GetWidth()/2
				Patronage_Settings.mmy = UIParent:GetHeight()/2
			end
			PAT.UI.mm:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Patronage_Settings.mmx, Patronage_Settings.mmy)
		end
		if Patronage_Settings.expand.direction == "down" then
			if Patronage_Settings.expand.align == "left" then
				PAT.UI.popup.c:SetPoint("TOPLEFT", PAT.UI.mm, "BOTTOMLEFT", 0,0) 
			elseif Patronage_Settings.expand.align == "right" then
				PAT.UI.popup.c:SetPoint("TOPRIGHT", PAT.UI.mm, "BOTTOMRIGHT", 0,0) 
			end
		elseif Patronage_Settings.expand.direction == "up" then
			if Patronage_Settings.expand.align == "right" then
				PAT.UI.popup.c:SetPoint("BOTTOMRIGHT", PAT.UI.mm, "TOPRIGHT", 0,0)
			elseif Patronage_Settings.expand.align == "left" then
				PAT.UI.popup.c:SetPoint("BOTTOMLEFT", PAT.UI.mm, "TOPLEFT", 0,0)
			end
		end
	end
end

PAT.BuildUI()

Command.Event.Attach(Event.Ability.New.Add, PAT.Event_Ability_New_Add, "Event.Ability.New.Add")
Command.Event.Attach(Event.Ability.New.Remove, PAT.Event_Ability_New_Remove, "Event.Ability.New.Remove")
Command.Event.Attach(Command.Slash.Register("pat"), PAT.Command_Slash_Register, "Command.Slash.Register")
Command.Event.Attach(Event.System.Secure.Enter, PAT.Event_System_Secure_Enter, "Event.System.Secure.Enter")
Command.Event.Attach(Event.System.Secure.Leave, PAT.Event_System_Secure_Leave, "Event.System.Secure.Leave")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, PAT.Event_Addon_SavedVariables_Load_End, "Event.Addon.SavedVariables.Load.End")

print(string.format("v%s loaded.", addon.toc.Version))
